	.text   

load_point:
	cmpl    $0,sp_quick_load
	je      di_check_end
	movl    $1,sp_load_trapped
	movl    $1,z80_proc+52
	movl    $0,%edi
	jmp     loop_end
	.align  4
	.globl  sp_halfframe

sp_halfframe:
	movl    8(%esp),%eax
	movl    %eax,linesleft
	movl    4(%esp),%eax
	pushl   %ebp
	pushl   %edi
	pushl   %esi
	pushl   %ebx
	pushl   %es
	cld     
	movl    %eax,%edi
	movl    sp_image,%eax
	movl    %eax,scrptr
	movw    %ds,%ax
	movw    %ax,%es
	call    load_regs

new_loop:
	movl    sp_scline,%eax
	movl    sp_scri(,%eax,4),%eax
	movl    %eax,z80_proc+80
	call    step_loop
	pushl   %ebx
	movl    sp_scline,%ebx
	cmpl    $0,z80_proc+108
	jz      store_sound
	cmpl    $0,z80_proc+100
	je      ewloop
	movl    sppc_delay,%eax

wloop:
	testl   %eax,%eax
	jz      ewloop
	nop     
	nop     
	nop     
	nop     
	decl    %eax
	jmp     wloop

ewloop:
	movb    z80_proc+92,%al
	jmp     sound_end
	.align  4

store_sound:
	movb    z80_proc+96,%al
	movb    %al,sp_sound_buf(%ebx)
	movb    z80_proc+92,%al
	testb   $16,%al
	jz      sound_0
	movb    $240,z80_proc+96
	jmp     sound_end
	.align  4

sound_0:
	movb    $16,z80_proc+96

sound_end:
	movb    %al,sp_fe_outport_time(%ebx)
	cmpl    $0,z80_proc+104
	je      no_imp_change
	xorb    $64,z80_proc+88

no_imp_change:
	movzbl  sp_tape_impinfo(%ebx),%eax
	movl    %eax,z80_proc+104
	cmpl    $0,sp_updating
	jz      not_to_update
	movl    z80_proc+80,%eax
	cmpl    $-1,%eax
	jl      not_to_update
	je      only_border

scr_update:
	pushl   %ecx
	pushl   %edx
	pushl   %edi
	movl    sp_coli(,%ebx,4),%edx
	incl    %ebx
	andl    $1023,%ebx
	movl    %ebx,sp_scline
	movl    %eax,%ebx
	movl    scrptr,%edi
	movl    %edi,%eax
	addl    $320,%eax
	movl    %eax,scrptr
	movzbl  z80_proc+92,%ecx
	andb    $7,%cl
	cmpb    %cl,sp_lastborder
	jne     sbrd_change
	cmpl    $0,sp_border_update
	jne     sbrd_update
	addl    $32,%edi

sbrd_no_update:
	movl    %edx,%eax
	shrl    $3,%eax
	testb   $7,%dl
	jz      clear_cm
	movl    sp_scr_mark+2816(,%eax,4),%ecx

no_clear_cm:
	xorl    %eax,%eax
	xchgl   sp_scr_mark(,%ebx,4),%eax
	orl     %eax,%ecx
	jz      skip_update
	orl     %ecx,sp_imag_mark(,%edx,4)
	orl     %ecx,sp_imag_horiz
	shrl    $3,%edx
	btsl    %edx,sp_imag_vert
	pushl   %esi
	pushl   %ebp
	xorw    %si,%si
	movl    %esi,%eax
	shll    $5,%ebx
	shll    $5,%edx
	addl    %ebx,%esi
	leal    0x5800(%eax,%edx),%ebp
	movl    $15,%ebx
	pushl   %ecx
	subl    $4,%esp
	cmpl    $0,sp_flash_state
	jnz     scr_f1
	movl    sp_scr_f0_table,%edx
	jmp     scr_32_pixels
	.align  4

scr_f1:
	movl    sp_scr_f1_table,%edx
	jmp     scr_32_pixels
	.align  4

scr_32_pixels:
	testl   %ebx,%ecx
	jz      skip_32_pixels
	movl    %ebx,(%esp)
	movl    (%esi),%ecx
	movl    (%ebp),%ebx
	movb    %bl,%dh
	movb    %cl,%dl
	shrb    $2,%dl
	andb    $60,%dl
	movl    (%edx),%eax
	stosl   
	movb    %cl,%dl
	shlb    $2,%dl
	andb    $60,%dl
	movl    (%edx),%eax
	stosl   
	addl    $4,%esi
	movb    %bh,%dh
	shrl    $16,%ebx
	movb    %ch,%dl
	shrb    $2,%dl
	andb    $60,%dl
	movl    (%edx),%eax
	stosl   
	movb    %ch,%dl
	shlb    $2,%dl
	andb    $60,%dl
	movl    (%edx),%eax
	stosl   
	shrl    $16,%ecx
	movb    %bl,%dh
	movb    %cl,%dl
	shrb    $2,%dl
	andb    $60,%dl
	movl    (%edx),%eax
	stosl   
	movb    %cl,%dl
	shlb    $2,%dl
	andb    $60,%dl
	movl    (%edx),%eax
	stosl   
	addl    $4,%ebp
	movb    %bh,%dh
	movb    %ch,%dl
	shrb    $2,%dl
	andb    $60,%dl
	movl    (%edx),%eax
	stosl   
	movb    %ch,%dl
	shlb    $2,%dl
	andb    $60,%dl
	movl    (%edx),%eax
	stosl   
	movl    (%esp),%ebx
	shll    $4,%ebx
	jz      end_screen_line
	movl    4(%esp),%ecx
	jmp     scr_32_pixels
	.align  4

skip_32_pixels:
	addl    $4,%esi
	addl    $4,%ebp
	addl    $32,%edi
	shll    $4,%ebx
	jz      end_screen_line
	jmp     scr_32_pixels
	.align  4

end_screen_line:
	addl    $8,%esp
	popl    %ebp
	popl    %esi

skip_update:
	popl    %edi
	popl    %edx
	popl    %ecx
	jmp     update_end
	.align  4

sbrd_change:
	movl    $2,sp_border_update
	xchgb   %cl,sp_lastborder

sbrd_update:
	movb    sp_colors(,%ecx,1),%cl
	movb    %cl,%ch
	movw    %cx,%ax
	shll    $16,%eax
	movw    %cx,%ax
	xorl    %ecx,%ecx
	movb    $8,%cl
	rep     
	stosl   
	addl    $256,%edi
	movb    $8,%cl
	rep     
	stosl   
	subl    $288,%edi
	jmp     sbrd_no_update
	.align  4

clear_cm:
	xorl    %ecx,%ecx
	xchgl   sp_scr_mark+2816(,%eax,4),%ecx
	testl   %ecx,%ecx
	jz      no_clear_cm
	leal    sp_scr_mark(,%ebx,4),%eax
	orl     %ecx,(%eax)
	orl     %ecx,0x20(%eax)
	orl     %ecx,0x40(%eax)
	orl     %ecx,0x60(%eax)
	addl    $128,%eax
	orl     %ecx,(%eax)
	orl     %ecx,0x20(%eax)
	orl     %ecx,0x40(%eax)
	orl     %ecx,0x60(%eax)
	jmp     no_clear_cm
	.align  4

only_border:
	incl    %ebx
	andl    $1023,%ebx
	movl    %ebx,sp_scline
	pushl   %edi
	movl    %ecx,%ebx
	movzbl  z80_proc+92,%ecx
	andb    $7,%cl
	cmpb    %cl,sp_lastborder
	je      brd_no_change
	movl    $2,sp_border_update
	xchgb   %cl,sp_lastborder

brd_no_change:
	cmpl    $0,sp_border_update
	je      brd_no_update
	movb    sp_colors(,%ecx,1),%cl
	movb    %cl,%ch
	movw    %cx,%ax
	shll    $16,%eax
	movw    %cx,%ax
	movl    scrptr,%edi
	movl    $80,%ecx
	rep     
	stosl   

brd_no_update:
	addl    $320,scrptr
	movl    %ebx,%ecx
	popl    %edi
	jmp     update_end
	.align  4

not_to_update:
	incl    %ebx
	andl    $1023,%ebx
	movl    %ebx,sp_scline

update_end:
	popl    %ebx
	decl    linesleft
	jz      chunk_end
	addl    $224,%edi
	jmp     new_loop
	.align  4

chunk_end:
	call    store_regs
	movl    %edi,%eax
	popl    %es
	popl    %ebx
	popl    %esi
	popl    %edi
	popl    %ebp
	ret     
	.align  4
	.data   

linesleft:
	.long   0

scrptr:
	.long   0
	.text   
	.align  4

addflags:
	lahf    
	seto    %al
	andb    $40,%cl
	andb    $209,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	ret     
	.align  4

subflags:
	lahf    
	setno   %al
	orb     $215,%cl
	orb     $46,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	ret     
	.align  4

orflags:
	lahf    
	andb    $40,%cl
	andb    $196,%ah
	orb     %ah,%cl
	ret     
	.align  4

andflags:
	lahf    
	andb    $40,%cl
	orb     $16,%cl
	andb    $196,%ah
	orb     %ah,%cl
	ret     
	.align  4
	.align  4
	.globl  z80_local_init

z80_local_init:
	ret     
	.align  4
	.globl  z80_pushpc

z80_pushpc:
	pushl   %ebp
	pushl   %esi
	movl    z80_proc+28,%esi
	movl    z80_proc+32,%ebp
	xorl    %ecx,%ecx
	movw    %si,%ax
	cmpw    $23297,%bp
	jb      z80_pushpci_cmpx
	decw    %bp
	movb    %ah,(%ebp)
	decw    %bp
	movb    %al,(%ebp)
	jmp     z80_pushpci_end
	.align  4

z80_pushpci_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      z80_pushpci1_mid
	movb    %ah,(%ebp)
	cmpw    $23296,%bp
	jnb     z80_pushpci1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      z80_pushpci1_mid
	cmpl    $86,%edi
	jle     z80_pushpci1_mid
	subl    $2,%edi

z80_pushpci1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      z80_pushpci2_mid
	movb    %al,(%ebp)
	cmpw    $23296,%bp
	jnb     z80_pushpci2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      z80_pushpci2_mid
	cmpl    $86,%edi
	jle     z80_pushpci2_mid
	subl    $2,%edi

z80_pushpci2_mid:

z80_pushpci_end:
	movl    %ebp,z80_proc+32
	popl    %esi
	popl    %ebp
	ret     
	.align  4
	.globl  z80_step

z80_step:
	movl    4(%esp),%eax
	pushl   %ebp
	pushl   %edi
	pushl   %esi
	pushl   %ebx
	movl    %eax,%edi
	call    load_regs
	call    step_loop
	call    store_regs
	movl    %edi,%eax
	popl    %ebx
	popl    %esi
	popl    %edi
	popl    %ebp
	ret     
	.align  4

load_regs:
	movzwl  z80_proc+12,%ecx
	movl    z80_proc+0,%ebx
	movl    z80_proc+8,%edx
	movl    z80_proc+28,%esi
	movl    z80_proc+32,%ebp
	movb    z80_proc+16,%al
	andb    $128,z80_proc+16
	movb    %al,z80_proc+76
	ret     
	.align  4

store_regs:
	movw    %cx,z80_proc+12
	movl    %ebx,z80_proc+0
	movl    %edx,z80_proc+8
	movl    %esi,z80_proc+28
	movl    %ebp,z80_proc+32
	movb    z80_proc+76,%al
	andb    $127,%al
	orb     %al,z80_proc+16
	ret     
	.align  4

step_loop:
	cmpl    $0,z80_proc+52
	jnz     haltstate
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

loop_end:
	ret     
	.align  4

special_cb:
	incl    z80_proc+76
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table_cb(,%eax,4)
	.align  4

special_dd_cb:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table_dd_fd_cb(,%eax,4)
	.align  4

special_fd_cb:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table_dd_fd_cb(,%eax,4)
	.align  4

special_dd:
	incl    z80_proc+76
	subl    $4,%edi
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table_dd(,%eax,4)
	.align  4

special_ed:
	incl    z80_proc+76
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table_ed(,%eax,4)
	.align  4

special_fd:
	incl    z80_proc+76
	subl    $4,%edi
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table_fd(,%eax,4)
	.align  4

special_xx:
	decl    z80_proc+76
	cmpl    $0,%edi
	jng     loop_end
	jmp     *intr_table(,%eax,4)
	.align  4

nop:
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ex_af_afb:
	xchgw   z80_proc+48,%cx
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

djnz_e:
	decb    %bh
	jne     djnz_e_1
	incw    %si
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

djnz_e_1:
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%si
	incl    z80_proc+76
	subl    $13,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jr_e:
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%si
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jr_nz_e:
	testb   $64,%cl
	jz      jr_e
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jr_z_e:
	testb   $64,%cl
	jnz     jr_e
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jr_nc_e:
	testb   $1,%cl
	jz      jr_e
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jr_c_e:
	testb   $1,%cl
	jnz     jr_e
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_bc_nn:
	movb    (%esi),%bl
	incw    %si
	movb    (%esi),%bh
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_de_nn:
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movw    %ax,z80_proc+4
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_hl_nn:
	movb    (%esi),%dl
	incw    %si
	movb    (%esi),%dh
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_sp_nn:
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movw    %ax,%bp
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_hl_bc:
	addb    %bl,%dl
	adcb    %bh,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_hl_de:
	addb    z80_proc+4,%dl
	adcb    z80_proc+5,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_hl_hl:
	addb    %dl,%dl
	adcb    %dh,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_hl_sp:
	movw    %bp,%ax
	addb    %al,%dl
	adcb    %ah,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_bc:
	incw    %bx
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_de:
	incw    z80_proc+4
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_hl:
	incw    %dx
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_sp:
	incw    %bp
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_bc:
	decw    %bx
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_de:
	decw    z80_proc+4
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_hl:
	decw    %dx
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_sp:
	decw    %bp
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ibc_a:
	cmpb    $91,%bh
	jb      ld_ibc_a_scr
	movb    %ch,(%ebx)
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ibc_a_scr:
	testb   $192,%bh
	jz      ld_ibc_a_rom
	movb    %ch,(%ebx)
	movzwl  %bx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_ibc_a_rom
	cmpl    $86,%edi
	jle     ld_ibc_a_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ibc_a_rom:
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ide_a:
	movl    z80_proc+4,%eax
	cmpb    $91,%ah
	jb      ld_ide_a_scr
	movb    %ch,(%eax)
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ide_a_scr:
	testb   $192,%ah
	jz      ld_ide_a_rom
	movb    %ch,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_ide_a_rom
	cmpl    $86,%edi
	jle     ld_ide_a_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ide_a_rom:
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_hl:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	testb   $192,%ah
	jz      ld_inn_hl_mid
	movb    %dl,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn_hl_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn_hl_mid
	cmpl    $86,%edi
	jle     ld_inn_hl_mid
	subl    $2,%edi

ld_inn_hl_mid:
	incw    %ax
	cmpb    $91,%ah
	jb      ld_inn_hl_scr
	movb    %dh,(%eax)
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_hl_scr:
	testb   $192,%ah
	jz      ld_inn_hl_rom
	movb    %dh,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_inn_hl_rom
	cmpl    $86,%edi
	jle     ld_inn_hl_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_hl_rom:
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_a:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	cmpb    $91,%ah
	jb      ld_inn_a_scr
	movb    %ch,(%eax)
	incl    z80_proc+76
	subl    $13,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_a_scr:
	testb   $192,%ah
	jz      ld_inn_a_rom
	movb    %ch,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_inn_a_rom
	cmpl    $86,%edi
	jle     ld_inn_a_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $13,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_a_rom:
	incl    z80_proc+76
	subl    $13,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_ibc:
	movb    (%ebx),%ch
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_ide:
	movl    z80_proc+4,%eax
	movb    (%eax),%ch
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_hl_inn:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movb    (%eax),%dl
	incw    %ax
	movb    (%eax),%dh
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_inn:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movb    (%eax),%ch
	incl    z80_proc+76
	subl    $13,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_b:
	incb    %bh
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_c:
	incb    %bl
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_d:
	incb    z80_proc+5
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_e:
	incb    z80_proc+4
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_h:
	incb    %dh
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_l:
	incb    %dl
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_ihl:
	cmpb    $91,%dh
	jb      INC_scr
	incb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

INC_scr:
	testb   $192,%dh
	jz      INC_rom
	incb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      INC_rend
	cmpl    $86,%edi
	jle     INC_rend
	subl    $2,%edi
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

INC_rom:
	movb    (%edx),%al
	incb    %al
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl

INC_rend:
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_a:
	incb    %ch
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_b:
	decb    %bh
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_c:
	decb    %bl
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_d:
	decb    z80_proc+5
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_e:
	decb    z80_proc+4
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_h:
	decb    %dh
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_l:
	decb    %dl
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_ihl:
	cmpb    $91,%dh
	jb      DEC_scr
	decb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

DEC_scr:
	testb   $192,%dh
	jz      DEC_rom
	decb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      DEC_rend
	cmpl    $86,%edi
	jle     DEC_rend
	subl    $2,%edi
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

DEC_rom:
	movb    (%edx),%al
	decb    %al
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl

DEC_rend:
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_a:
	decb    %ch
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_n:
	movb    (%esi),%bh
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_n:
	movb    (%esi),%bl
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_n:
	movb    (%esi),%al
	incw    %si
	movb    %al,z80_proc+5
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_n:
	movb    (%esi),%al
	incw    %si
	movb    %al,z80_proc+4
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_h_n:
	movb    (%esi),%dh
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_l_n:
	movb    (%esi),%dl
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_n:
	movb    (%esi),%al
	incw    %si
	cmpb    $91,%dh
	jb      ld_ihl_n_scr
	movb    %al,(%edx)
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_n_scr:
	testb   $192,%dh
	jz      ld_ihl_n_rom
	movb    %al,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_ihl_n_rom
	cmpl    $86,%edi
	jle     ld_ihl_n_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_n_rom:
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_n:
	movb    (%esi),%ch
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rlca:
	rolb    %ch
	lahf    
	andb    $236,%cl
	andb    $1,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrca:
	rorb    %ch
	lahf    
	andb    $236,%cl
	andb    $1,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rla:
	movb    %cl,%ah
	sahf    
	rclb    %ch
	lahf    
	andb    $236,%cl
	andb    $1,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rra:
	movb    %cl,%ah
	sahf    
	rcrb    %ch
	lahf    
	andb    $236,%cl
	andb    $1,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

daa:
	movb    %ch,%al
	testb   $2,%cl
	jnz     daa_s
	movb    %cl,%ah
	sahf    
	daa     
	movb    %al,%ch
	lahf    
	andb    $42,%cl
	andb    $213,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

daa_s:
	movb    %cl,%ah
	sahf    
	das     
	movb    %al,%ch
	lahf    
	andb    $42,%cl
	andb    $213,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cpl:
	notb    %ch
	orb     $18,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

scf:
	andb    $237,%cl
	orb     $1,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ccf:
	xorb    $1,%cl
	andb    $253,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movb    (%esi),%al
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ix_nn:
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movw    %ax,z80_proc+20
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_ix_bc:
	xchgw   %dx,z80_proc+20
	addb    %bl,%dl
	adcb    %bh,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	xchgw   %dx,z80_proc+20
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_ix_de:
	xchgw   %dx,z80_proc+20
	addb    z80_proc+4,%dl
	adcb    z80_proc+5,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	xchgw   %dx,z80_proc+20
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_ix_ix:
	xchgw   %dx,z80_proc+20
	addb    %dl,%dl
	adcb    %dh,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	xchgw   %dx,z80_proc+20
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_ix_sp:
	movw    %bp,%ax
	xchgw   %dx,z80_proc+20
	addb    %al,%dl
	adcb    %ah,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	xchgw   %dx,z80_proc+20
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_ix:
	incw    z80_proc+20
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_ix:
	decw    z80_proc+20
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_ix:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	xchgw   %dx,z80_proc+20
	testb   $192,%ah
	jz      ld_inn_ix1_mid
	movb    %dl,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn_ix1_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn_ix1_mid
	cmpl    $86,%edi
	jle     ld_inn_ix1_mid
	subl    $2,%edi

ld_inn_ix1_mid:
	incw    %ax
	testb   $192,%ah
	jz      ld_inn_ix2_mid
	movb    %dh,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn_ix2_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn_ix2_mid
	cmpl    $86,%edi
	jle     ld_inn_ix2_mid
	subl    $2,%edi

ld_inn_ix2_mid:
	xchgw   %dx,z80_proc+20
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ix_inn:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	xchgw   %dx,z80_proc+20
	movb    (%eax),%dl
	incw    %ax
	movb    (%eax),%dh
	xchgw   %dx,z80_proc+20
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_iixd:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	cmpb    $91,%dh
	jb      INCix_scr
	incb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

INCix_scr:
	testb   $192,%dh
	jz      INCix_rom
	incb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      INCix_rend
	cmpl    $86,%edi
	jle     INCix_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

INCix_rom:
	movb    (%edx),%al
	incb    %al
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl

INCix_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_ixh:
	incb    z80_proc+21
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_ixl:
	incb    z80_proc+20
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_iixd:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	cmpb    $91,%dh
	jb      DECix_scr
	decb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

DECix_scr:
	testb   $192,%dh
	jz      DECix_rom
	decb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      DECix_rend
	cmpl    $86,%edi
	jle     DECix_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

DECix_rom:
	movb    (%edx),%al
	decb    %al
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl

DECix_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_ixh:
	decb    z80_proc+21
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_ixl:
	decb    z80_proc+20
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_n:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	movb    (%esi),%al
	incw    %si
	cmpb    $91,%dh
	jb      ld_iixd_n_scr
	movb    %al,(%edx)
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_n_scr:
	testb   $192,%dh
	jz      ld_iixd_n_rom
	movb    %al,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iixd_n_rom
	cmpl    $86,%edi
	jle     ld_iixd_n_rom
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_n_rom:
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixh_n:
	movb    (%esi),%al
	incw    %si
	movb    %al,z80_proc+21
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixl_n:
	movb    (%esi),%al
	incw    %si
	movb    %al,z80_proc+20
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iy_nn:
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movw    %ax,z80_proc+24
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_iy_bc:
	xchgw   %dx,z80_proc+24
	addb    %bl,%dl
	adcb    %bh,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	xchgw   %dx,z80_proc+24
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_iy_de:
	xchgw   %dx,z80_proc+24
	addb    z80_proc+4,%dl
	adcb    z80_proc+5,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	xchgw   %dx,z80_proc+24
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_iy_iy:
	xchgw   %dx,z80_proc+24
	addb    %dl,%dl
	adcb    %dh,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	xchgw   %dx,z80_proc+24
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_iy_sp:
	movw    %bp,%ax
	xchgw   %dx,z80_proc+24
	addb    %al,%dl
	adcb    %ah,%dh
	lahf    
	andb    $236,%cl
	andb    $17,%ah
	orb     %ah,%cl
	xchgw   %dx,z80_proc+24
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_iy:
	incw    z80_proc+24
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_iy:
	decw    z80_proc+24
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_iy:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	xchgw   %dx,z80_proc+24
	testb   $192,%ah
	jz      ld_inn_iy1_mid
	movb    %dl,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn_iy1_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn_iy1_mid
	cmpl    $86,%edi
	jle     ld_inn_iy1_mid
	subl    $2,%edi

ld_inn_iy1_mid:
	incw    %ax
	testb   $192,%ah
	jz      ld_inn_iy2_mid
	movb    %dh,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn_iy2_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn_iy2_mid
	cmpl    $86,%edi
	jle     ld_inn_iy2_mid
	subl    $2,%edi

ld_inn_iy2_mid:
	xchgw   %dx,z80_proc+24
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iy_inn:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	xchgw   %dx,z80_proc+24
	movb    (%eax),%dl
	incw    %ax
	movb    (%eax),%dh
	xchgw   %dx,z80_proc+24
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_iiyd:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	cmpb    $91,%dh
	jb      INCiy_scr
	incb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

INCiy_scr:
	testb   $192,%dh
	jz      INCiy_rom
	incb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      INCiy_rend
	cmpl    $86,%edi
	jle     INCiy_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

INCiy_rom:
	movb    (%edx),%al
	incb    %al
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl

INCiy_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_iyh:
	incb    z80_proc+25
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inc_iyl:
	incb    z80_proc+24
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_iiyd:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	cmpb    $91,%dh
	jb      DECiy_scr
	decb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

DECiy_scr:
	testb   $192,%dh
	jz      DECiy_rom
	decb    (%edx)
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      DECiy_rend
	cmpl    $86,%edi
	jle     DECiy_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

DECiy_rom:
	movb    (%edx),%al
	decb    %al
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl

DECiy_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_iyh:
	decb    z80_proc+25
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

dec_iyl:
	decb    z80_proc+24
	lahf    
	seto    %al
	andb    $59,%cl
	andb    $192,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_n:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	movb    (%esi),%al
	incw    %si
	cmpb    $91,%dh
	jb      ld_iiyd_n_scr
	movb    %al,(%edx)
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_n_scr:
	testb   $192,%dh
	jz      ld_iiyd_n_rom
	movb    %al,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iiyd_n_rom
	cmpl    $86,%edi
	jle     ld_iiyd_n_rom
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_n_rom:
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyh_n:
	movb    (%esi),%al
	incw    %si
	movb    %al,z80_proc+25
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyl_n:
	movb    (%esi),%al
	incw    %si
	movb    %al,z80_proc+24
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

halt:
	movl    $1,z80_proc+52

haltstate:
	movl    %edi,%eax
	testl   %eax,%eax
	jz      haltstate_tc0
	decl    %eax

haltstate_tc0:
	sarl    $2,%eax
	incl    %eax
	addl    %eax,z80_proc+76
	leal    0(,%eax,4),%eax
	subl    %eax,%edi
	jmp     loop_end
	.align  4

ld_b_c:
	movb    %bl,%bh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_d:
	movb    z80_proc+5,%bh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_e:
	movb    z80_proc+4,%bh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_h:
	movb    %dh,%bh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_l:
	movb    %dl,%bh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_ihl:
	movb    (%edx),%bh
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_a:
	movb    %ch,%bh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_b:
	movb    %bh,%bl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_d:
	movb    z80_proc+5,%bl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_e:
	movb    z80_proc+4,%bl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_h:
	movb    %dh,%bl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_l:
	movb    %dl,%bl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_ihl:
	movb    (%edx),%bl
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_a:
	movb    %ch,%bl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_b:
	movb    %bh,z80_proc+5
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_c:
	movb    %bl,z80_proc+5
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_e:
	movb    z80_proc+4,%al
	movb    %al,z80_proc+5
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_h:
	movb    %dh,z80_proc+5
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_l:
	movb    %dl,z80_proc+5
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_ihl:
	movb    (%edx),%al
	movb    %al,z80_proc+5
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_a:
	movb    %ch,z80_proc+5
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_b:
	movb    %bh,z80_proc+4
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_c:
	movb    %bl,z80_proc+4
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_d:
	movb    z80_proc+5,%al
	movb    %al,z80_proc+4
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_h:
	movb    %dh,z80_proc+4
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_l:
	movb    %dl,z80_proc+4
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_ihl:
	movb    (%edx),%al
	movb    %al,z80_proc+4
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_a:
	movb    %ch,z80_proc+4
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_h_b:
	movb    %bh,%dh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_h_c:
	movb    %bl,%dh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_h_d:
	movb    z80_proc+5,%dh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_h_e:
	movb    z80_proc+4,%dh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_h_l:
	movb    %dl,%dh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_h_ihl:
	movb    (%edx),%dh
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_h_a:
	movb    %ch,%dh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_l_b:
	movb    %bh,%dl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_l_c:
	movb    %bl,%dl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_l_d:
	movb    z80_proc+5,%dl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_l_e:
	movb    z80_proc+4,%dl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_l_h:
	movb    %dh,%dl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_l_ihl:
	movb    (%edx),%dl
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_l_a:
	movb    %ch,%dl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_b:
	cmpb    $91,%dh
	jb      ld_ihl_RB_scr
	movb    %bh,(%edx)
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RB_scr:
	testb   $192,%dh
	jz      ld_ihl_RB_rom
	movb    %bh,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_ihl_RB_rom
	cmpl    $86,%edi
	jle     ld_ihl_RB_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RB_rom:
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_c:
	cmpb    $91,%dh
	jb      ld_ihl_RC_scr
	movb    %bl,(%edx)
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RC_scr:
	testb   $192,%dh
	jz      ld_ihl_RC_rom
	movb    %bl,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_ihl_RC_rom
	cmpl    $86,%edi
	jle     ld_ihl_RC_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RC_rom:
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_d:
	movb    z80_proc+5,%ah
	cmpb    $91,%dh
	jb      ld_ihl_RV_scr
	movb    %ah,(%edx)
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RV_scr:
	testb   $192,%dh
	jz      ld_ihl_RV_rom
	movb    %ah,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_ihl_RV_rom
	cmpl    $86,%edi
	jle     ld_ihl_RV_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RV_rom:
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_e:
	movb    z80_proc+4,%al
	cmpb    $91,%dh
	jb      ld_ihl_RW_scr
	movb    %al,(%edx)
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RW_scr:
	testb   $192,%dh
	jz      ld_ihl_RW_rom
	movb    %al,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_ihl_RW_rom
	cmpl    $86,%edi
	jle     ld_ihl_RW_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RW_rom:
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_h:
	cmpb    $91,%dh
	jb      ld_ihl_RH_scr
	movb    %dh,(%edx)
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RH_scr:
	testb   $192,%dh
	jz      ld_ihl_RH_rom
	movb    %dh,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_ihl_RH_rom
	cmpl    $86,%edi
	jle     ld_ihl_RH_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RH_rom:
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_l:
	cmpb    $91,%dh
	jb      ld_ihl_RL_scr
	movb    %dl,(%edx)
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RL_scr:
	testb   $192,%dh
	jz      ld_ihl_RL_rom
	movb    %dl,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_ihl_RL_rom
	cmpl    $86,%edi
	jle     ld_ihl_RL_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RL_rom:
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_a:
	cmpb    $91,%dh
	jb      ld_ihl_RA_scr
	movb    %ch,(%edx)
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RA_scr:
	testb   $192,%dh
	jz      ld_ihl_RA_rom
	movb    %ch,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_ihl_RA_rom
	cmpl    $86,%edi
	jle     ld_ihl_RA_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ihl_RA_rom:
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_b:
	movb    %bh,%ch
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_c:
	movb    %bl,%ch
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_d:
	movb    z80_proc+5,%ch
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_e:
	movb    z80_proc+4,%ch
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_h:
	movb    %dh,%ch
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_l:
	movb    %dl,%ch
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_ihl:
	movb    (%edx),%ch
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_iixd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	movb    (%eax),%bh
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_ixh:
	movb    z80_proc+21,%bh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_ixl:
	movb    z80_proc+20,%bh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_iixd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	movb    (%eax),%bl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_ixh:
	movb    z80_proc+21,%bl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_ixl:
	movb    z80_proc+20,%bl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_iixd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	movb    (%eax),%al
	movb    %al,z80_proc+5
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_ixh:
	movb    z80_proc+21,%al
	movb    %al,z80_proc+5
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_ixl:
	movb    z80_proc+20,%al
	movb    %al,z80_proc+5
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_iixd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	movb    (%eax),%al
	movb    %al,z80_proc+4
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_ixh:
	movb    z80_proc+21,%al
	movb    %al,z80_proc+4
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_ixl:
	movb    z80_proc+20,%al
	movb    %al,z80_proc+4
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_h_iixd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	movb    (%eax),%dh
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixh_b:
	movb    %bh,z80_proc+21
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixh_c:
	movb    %bl,z80_proc+21
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixh_d:
	movb    z80_proc+5,%al
	movb    %al,z80_proc+21
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixh_e:
	movb    z80_proc+4,%al
	movb    %al,z80_proc+21
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixh_ixl:
	movb    z80_proc+20,%al
	movb    %al,z80_proc+21
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixh_a:
	movb    %ch,z80_proc+21
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_l_iixd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	movb    (%eax),%dl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixl_b:
	movb    %bh,z80_proc+20
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixl_c:
	movb    %bl,z80_proc+20
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixl_d:
	movb    z80_proc+5,%al
	movb    %al,z80_proc+20
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixl_e:
	movb    z80_proc+4,%al
	movb    %al,z80_proc+20
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixl_ixh:
	movb    z80_proc+21,%al
	movb    %al,z80_proc+20
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_ixl_a:
	movb    %ch,z80_proc+20
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_b:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	cmpb    $91,%ah
	jb      ld_iixd_RB_scr
	movb    %bh,(%eax)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_RB_scr:
	testb   $192,%ah
	jz      ld_iixd_RB_rom
	movb    %bh,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iixd_RB_rom
	cmpl    $86,%edi
	jle     ld_iixd_RB_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_RB_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_c:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	cmpb    $91,%ah
	jb      ld_iixd_RC_scr
	movb    %bl,(%eax)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_RC_scr:
	testb   $192,%ah
	jz      ld_iixd_RC_rom
	movb    %bl,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iixd_RC_rom
	cmpl    $86,%edi
	jle     ld_iixd_RC_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_RC_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_d:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	pushl   %edx
	movb    z80_proc+5,%dl
	testb   $192,%ah
	jz      ld_iixd_MD_mid
	movb    %dl,(%eax)
	cmpb    $91,%ah
	jnb     ld_iixd_MD_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_iixd_MD_mid
	cmpl    $86,%edi
	jle     ld_iixd_MD_mid
	subl    $2,%edi

ld_iixd_MD_mid:
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_e:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	pushl   %edx
	movb    z80_proc+4,%dl
	testb   $192,%ah
	jz      ld_iixd_ME_mid
	movb    %dl,(%eax)
	cmpb    $91,%ah
	jnb     ld_iixd_ME_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_iixd_ME_mid
	cmpl    $86,%edi
	jle     ld_iixd_ME_mid
	subl    $2,%edi

ld_iixd_ME_mid:
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_h:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	cmpb    $91,%ah
	jb      ld_iixd_RH_scr
	movb    %dh,(%eax)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_RH_scr:
	testb   $192,%ah
	jz      ld_iixd_RH_rom
	movb    %dh,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iixd_RH_rom
	cmpl    $86,%edi
	jle     ld_iixd_RH_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_RH_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_l:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	cmpb    $91,%ah
	jb      ld_iixd_RL_scr
	movb    %dl,(%eax)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_RL_scr:
	testb   $192,%ah
	jz      ld_iixd_RL_rom
	movb    %dl,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iixd_RL_rom
	cmpl    $86,%edi
	jle     ld_iixd_RL_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_RL_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_a:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	cmpb    $91,%ah
	jb      ld_iixd_RA_scr
	movb    %ch,(%eax)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_RA_scr:
	testb   $192,%ah
	jz      ld_iixd_RA_rom
	movb    %ch,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iixd_RA_rom
	cmpl    $86,%edi
	jle     ld_iixd_RA_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iixd_RA_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_iixd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+20,%ax
	movb    (%eax),%ch
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_ixh:
	movb    z80_proc+21,%ch
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_ixl:
	movb    z80_proc+20,%ch
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_iiyd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	movb    (%eax),%bh
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_iyh:
	movb    z80_proc+25,%bh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_b_iyl:
	movb    z80_proc+24,%bh
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_iiyd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	movb    (%eax),%bl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_iyh:
	movb    z80_proc+25,%bl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_c_iyl:
	movb    z80_proc+24,%bl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_iiyd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	movb    (%eax),%al
	movb    %al,z80_proc+5
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_iyh:
	movb    z80_proc+25,%al
	movb    %al,z80_proc+5
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_d_iyl:
	movb    z80_proc+24,%al
	movb    %al,z80_proc+5
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_iiyd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	movb    (%eax),%al
	movb    %al,z80_proc+4
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_iyh:
	movb    z80_proc+25,%al
	movb    %al,z80_proc+4
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_e_iyl:
	movb    z80_proc+24,%al
	movb    %al,z80_proc+4
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_h_iiyd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	movb    (%eax),%dh
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyh_b:
	movb    %bh,z80_proc+25
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyh_c:
	movb    %bl,z80_proc+25
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyh_d:
	movb    z80_proc+5,%al
	movb    %al,z80_proc+25
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyh_e:
	movb    z80_proc+4,%al
	movb    %al,z80_proc+25
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyh_iyl:
	movb    z80_proc+24,%al
	movb    %al,z80_proc+25
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyh_a:
	movb    %ch,z80_proc+25
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_l_iiyd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	movb    (%eax),%dl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyl_b:
	movb    %bh,z80_proc+24
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyl_c:
	movb    %bl,z80_proc+24
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyl_d:
	movb    z80_proc+5,%al
	movb    %al,z80_proc+24
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyl_e:
	movb    z80_proc+4,%al
	movb    %al,z80_proc+24
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyl_iyh:
	movb    z80_proc+25,%al
	movb    %al,z80_proc+24
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iyl_a:
	movb    %ch,z80_proc+24
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_b:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	cmpb    $91,%ah
	jb      ld_iiyd_RB_scr
	movb    %bh,(%eax)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_RB_scr:
	testb   $192,%ah
	jz      ld_iiyd_RB_rom
	movb    %bh,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iiyd_RB_rom
	cmpl    $86,%edi
	jle     ld_iiyd_RB_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_RB_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_c:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	cmpb    $91,%ah
	jb      ld_iiyd_RC_scr
	movb    %bl,(%eax)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_RC_scr:
	testb   $192,%ah
	jz      ld_iiyd_RC_rom
	movb    %bl,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iiyd_RC_rom
	cmpl    $86,%edi
	jle     ld_iiyd_RC_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_RC_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_d:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	pushl   %edx
	movb    z80_proc+5,%dl
	testb   $192,%ah
	jz      ld_iiyd_MD_mid
	movb    %dl,(%eax)
	cmpb    $91,%ah
	jnb     ld_iiyd_MD_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_iiyd_MD_mid
	cmpl    $86,%edi
	jle     ld_iiyd_MD_mid
	subl    $2,%edi

ld_iiyd_MD_mid:
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_e:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	pushl   %edx
	movb    z80_proc+4,%dl
	testb   $192,%ah
	jz      ld_iiyd_ME_mid
	movb    %dl,(%eax)
	cmpb    $91,%ah
	jnb     ld_iiyd_ME_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_iiyd_ME_mid
	cmpl    $86,%edi
	jle     ld_iiyd_ME_mid
	subl    $2,%edi

ld_iiyd_ME_mid:
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_h:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	cmpb    $91,%ah
	jb      ld_iiyd_RH_scr
	movb    %dh,(%eax)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_RH_scr:
	testb   $192,%ah
	jz      ld_iiyd_RH_rom
	movb    %dh,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iiyd_RH_rom
	cmpl    $86,%edi
	jle     ld_iiyd_RH_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_RH_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_l:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	cmpb    $91,%ah
	jb      ld_iiyd_RL_scr
	movb    %dl,(%eax)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_RL_scr:
	testb   $192,%ah
	jz      ld_iiyd_RL_rom
	movb    %dl,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iiyd_RL_rom
	cmpl    $86,%edi
	jle     ld_iiyd_RL_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_RL_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_a:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	cmpb    $91,%ah
	jb      ld_iiyd_RA_scr
	movb    %ch,(%eax)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_RA_scr:
	testb   $192,%ah
	jz      ld_iiyd_RA_rom
	movb    %ch,(%eax)
	movzwl  %ax,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      ld_iiyd_RA_rom
	cmpl    $86,%edi
	jle     ld_iiyd_RA_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_iiyd_RA_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_iiyd:
	movl    %edx,%eax
	movsbw  (%esi),%ax
	incw    %si
	addw    z80_proc+24,%ax
	movb    (%eax),%ch
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_iyh:
	movb    z80_proc+25,%ch
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_iyl:
	movb    z80_proc+24,%ch
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_b:
	addb    %bh,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_c:
	addb    %bl,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_d:
	addb    z80_proc+5,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_e:
	addb    z80_proc+4,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_h:
	addb    %dh,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_l:
	addb    %dl,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_ihl:
	addb    (%edx),%ch
	call    addflags
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_a:
	addb    %ch,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_b:
	movb    %cl,%ah
	sahf    
	adcb    %bh,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_c:
	movb    %cl,%ah
	sahf    
	adcb    %bl,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_d:
	movb    %cl,%ah
	sahf    
	adcb    z80_proc+5,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_e:
	movb    %cl,%ah
	sahf    
	adcb    z80_proc+4,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_h:
	movb    %cl,%ah
	sahf    
	adcb    %dh,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_l:
	movb    %cl,%ah
	sahf    
	adcb    %dl,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_ihl:
	movb    %cl,%ah
	sahf    
	adcb    (%edx),%ch
	call    addflags
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_a:
	movb    %cl,%ah
	sahf    
	adcb    %ch,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_b:
	subb    %bh,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_c:
	subb    %bl,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_d:
	subb    z80_proc+5,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_e:
	subb    z80_proc+4,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_h:
	subb    %dh,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_l:
	subb    %dl,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_ihl:
	subb    (%edx),%ch
	call    subflags
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_a:
	subb    %ch,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_b:
	movb    %cl,%ah
	sahf    
	sbbb    %bh,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_c:
	movb    %cl,%ah
	sahf    
	sbbb    %bl,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_d:
	movb    %cl,%ah
	sahf    
	sbbb    z80_proc+5,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_e:
	movb    %cl,%ah
	sahf    
	sbbb    z80_proc+4,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_h:
	movb    %cl,%ah
	sahf    
	sbbb    %dh,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_l:
	movb    %cl,%ah
	sahf    
	sbbb    %dl,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_ihl:
	movb    %cl,%ah
	sahf    
	sbbb    (%edx),%ch
	call    subflags
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_a:
	movb    %cl,%ah
	sahf    
	sbbb    %ch,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_b:
	andb    %bh,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_c:
	andb    %bl,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_d:
	andb    z80_proc+5,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_e:
	andb    z80_proc+4,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_h:
	andb    %dh,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_l:
	andb    %dl,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_ihl:
	andb    (%edx),%ch
	call    andflags
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_a:
	andb    %ch,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_b:
	xorb    %bh,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_c:
	xorb    %bl,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_d:
	xorb    z80_proc+5,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_e:
	xorb    z80_proc+4,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_h:
	xorb    %dh,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_l:
	xorb    %dl,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_ihl:
	xorb    (%edx),%ch
	call    orflags
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_a:
	xorb    %ch,%ch
	andb    $40,%cl
	orb     $68,%cl
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_b:
	orb     %bh,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_c:
	orb     %bl,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_d:
	orb     z80_proc+5,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_e:
	orb     z80_proc+4,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_h:
	orb     %dh,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_l:
	orb     %dl,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_ihl:
	orb     (%edx),%ch
	call    orflags
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_a:
	orb     %ch,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_b:
	cmpb    %bh,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_c:
	cmpb    %bl,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_d:
	cmpb    z80_proc+5,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_e:
	cmpb    z80_proc+4,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_h:
	cmpb    %dh,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_l:
	cmpb    %dl,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_ihl:
	cmpb    (%edx),%ch
	call    subflags
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_a:
	cmpb    %ch,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_iixd:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	addb    (%edx),%ch
	call    addflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_ixh:
	addb    z80_proc+21,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_ixl:
	addb    z80_proc+20,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_iixd:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	movb    %cl,%ah
	sahf    
	adcb    (%edx),%ch
	call    addflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_ixh:
	movb    %cl,%ah
	sahf    
	adcb    z80_proc+21,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_ixl:
	movb    %cl,%ah
	sahf    
	adcb    z80_proc+20,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_iixd:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	subb    (%edx),%ch
	call    subflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_ixh:
	subb    z80_proc+21,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_ixl:
	subb    z80_proc+20,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_iixd:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	movb    %cl,%ah
	sahf    
	sbbb    (%edx),%ch
	call    subflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_ixh:
	movb    %cl,%ah
	sahf    
	sbbb    z80_proc+21,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_ixl:
	movb    %cl,%ah
	sahf    
	sbbb    z80_proc+20,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_iixd:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	andb    (%edx),%ch
	call    andflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_ixh:
	andb    z80_proc+21,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_ixl:
	andb    z80_proc+20,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_iixd:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	xorb    (%edx),%ch
	call    orflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_ixh:
	xorb    z80_proc+21,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_ixl:
	xorb    z80_proc+20,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_iixd:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	orb     (%edx),%ch
	call    orflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_ixh:
	orb     z80_proc+21,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_ixl:
	orb     z80_proc+20,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_iixd:
	pushl   %edx
	movw    z80_proc+20,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	cmpb    (%edx),%ch
	call    subflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_ixh:
	cmpb    z80_proc+21,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_ixl:
	cmpb    z80_proc+20,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_iiyd:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	addb    (%edx),%ch
	call    addflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_iyh:
	addb    z80_proc+25,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_iyl:
	addb    z80_proc+24,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_iiyd:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	movb    %cl,%ah
	sahf    
	adcb    (%edx),%ch
	call    addflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_iyh:
	movb    %cl,%ah
	sahf    
	adcb    z80_proc+25,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_iyl:
	movb    %cl,%ah
	sahf    
	adcb    z80_proc+24,%ch
	call    addflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_iiyd:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	subb    (%edx),%ch
	call    subflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_iyh:
	subb    z80_proc+25,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_iyl:
	subb    z80_proc+24,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_iiyd:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	movb    %cl,%ah
	sahf    
	sbbb    (%edx),%ch
	call    subflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_iyh:
	movb    %cl,%ah
	sahf    
	sbbb    z80_proc+25,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_iyl:
	movb    %cl,%ah
	sahf    
	sbbb    z80_proc+24,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_iiyd:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	andb    (%edx),%ch
	call    andflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_iyh:
	andb    z80_proc+25,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_iyl:
	andb    z80_proc+24,%ch
	call    andflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_iiyd:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	xorb    (%edx),%ch
	call    orflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_iyh:
	xorb    z80_proc+25,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_iyl:
	xorb    z80_proc+24,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_iiyd:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	orb     (%edx),%ch
	call    orflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_iyh:
	orb     z80_proc+25,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_iyl:
	orb     z80_proc+24,%ch
	call    orflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_iiyd:
	pushl   %edx
	movw    z80_proc+24,%dx
	movsbw  (%esi),%ax
	incw    %si
	addw    %ax,%dx
	cmpb    (%edx),%ch
	call    subflags
	popl    %edx
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_iyh:
	cmpb    z80_proc+25,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_iyl:
	cmpb    z80_proc+24,%ch
	call    subflags
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ret_cc:
	movb    (%ebp),%al
	incw    %bp
	movb    (%ebp),%ah
	incw    %bp
	movw    %ax,%si
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ret:
	movb    (%ebp),%al
	incw    %bp
	movb    (%ebp),%ah
	incw    %bp
	movw    %ax,%si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ret_nz:
	testb   $64,%cl
	jz      ret_cc
	incl    z80_proc+76
	subl    $5,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ret_z:
	testb   $64,%cl
	jnz     ret_cc
	incl    z80_proc+76
	subl    $5,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ret_nc:
	testb   $1,%cl
	jz      ret_cc
	incl    z80_proc+76
	subl    $5,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ret_c:
	testb   $1,%cl
	jnz     ret_cc
	incl    z80_proc+76
	subl    $5,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ret_po:
	testb   $4,%cl
	jz      ret_cc
	incl    z80_proc+76
	subl    $5,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ret_pe:
	testb   $4,%cl
	jnz     ret_cc
	incl    z80_proc+76
	subl    $5,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ret_p:
	testb   $128,%cl
	jz      ret_cc
	incl    z80_proc+76
	subl    $5,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ret_m:
	testb   $128,%cl
	jnz     ret_cc
	incl    z80_proc+76
	subl    $5,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pop_bc:
	movb    (%ebp),%bl
	incw    %bp
	movb    (%ebp),%bh
	incw    %bp
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pop_de:
	movb    (%ebp),%al
	incw    %bp
	movb    (%ebp),%ah
	incw    %bp
	movw    %ax,z80_proc+4
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pop_hl:
	movb    (%ebp),%dl
	incw    %bp
	movb    (%ebp),%dh
	incw    %bp
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pop_ix:
	movb    (%ebp),%al
	incw    %bp
	movb    (%ebp),%ah
	incw    %bp
	movw    %ax,z80_proc+20
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pop_iy:
	movb    (%ebp),%al
	incw    %bp
	movb    (%ebp),%ah
	incw    %bp
	movw    %ax,z80_proc+24
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pop_af:
	movb    (%ebp),%cl
	incw    %bp
	movb    (%ebp),%ch
	incw    %bp
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

exx:
	xchgw   z80_proc+36,%bx
	movw    z80_proc+4,%ax
	xchgw   z80_proc+40,%ax
	movw    %ax,z80_proc+4
	xchgw   z80_proc+44,%dx
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_hl:
	movw    %dx,%si
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_ix:
	movw    z80_proc+20,%si
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_iy:
	movw    z80_proc+24,%si
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_sp_hl:
	movw    %dx,%bp
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_sp_ix:
	movw    z80_proc+20,%bp
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_sp_iy:
	movw    z80_proc+24,%bp
	incl    z80_proc+76
	subl    $6,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_cc_nn:

jp_nn:
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movw    %ax,%si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_nz_nn:
	testb   $64,%cl
	jz      jp_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_z_nn:
	testb   $64,%cl
	jnz     jp_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_nc_nn:
	testb   $1,%cl
	jz      jp_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_c_nn:
	testb   $1,%cl
	jnz     jp_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_po_nn:
	testb   $4,%cl
	jz      jp_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_pe_nn:
	testb   $4,%cl
	jnz     jp_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_p_nn:
	testb   $128,%cl
	jz      jp_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

jp_m_nn:
	testb   $128,%cl
	jnz     jp_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

out_in_a:
	testb   $1,(%esi)
	jnz     out_in_a_out_nonfe
	movb    %ch,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %ch,z80_proc+92
	testb   $16,%ah
	jz      out_in_a_out_end
	movl    $1,z80_proc+100
	testb   $16,%ch
	jz      out_in_a_out_s_0
	addl    %edi,z80_proc+96
	jmp     out_in_a_out_end
	.align  4

out_in_a_out_s_0:
	subl    %edi,z80_proc+96
	jmp     out_in_a_out_end
	.align  4

out_in_a_out_nonfe:
	movzbl  (%esi),%eax
	movb    %ch,z80_outports(%eax)

out_in_a_out_end:
	incw    %si
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

in_a_in:
	movl    z80_proc+84,%eax
	testb   %al,(%esi)
	jz      in_a_in_in_active
	testb   $1,(%esi)
	jnz     in_a_in_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      in_a_in_in_imp
	movzbl  %ch,%eax
	movb    sp_fe_inport_high(%eax),%ch
	andb    z80_proc+88,%ch
	decl    %edi
	jmp     in_a_in_in_end
	.align  4

in_a_in_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %ch,%eax
	movb    sp_fe_inport_high(%eax),%ch
	andb    z80_proc+88,%ch
	decl    %edi
	jmp     in_a_in_in_end
	.align  4

in_a_in_in_active:
	movzbl  (%esi),%eax
	movb    z80_inports(%eax),%ch
	jmp     in_a_in_in_end
	.align  4

in_a_in_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      in_a_in_in_ulaidle
	cmpl    $96,%edi
	jle     in_a_in_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%ch
	jmp     in_a_in_in_end

in_a_in_in_ulaidle:
	movb    $255,%ch
	jmp     in_a_in_in_end
	.align  4

in_a_in_in_end:
	incw    %si
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ex_isp_hl:
	movb    (%ebp),%al
	incw    %bp
	movb    (%ebp),%ah
	incw    %bp
	cmpw    $23297,%bp
	jb      ex_isp_hl_cmpx
	decw    %bp
	movb    %dh,(%ebp)
	decw    %bp
	movb    %dl,(%ebp)
	jmp     ex_isp_hl_end
	.align  4

ex_isp_hl_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      ex_isp_hl1_mid
	movb    %dh,(%ebp)
	cmpw    $23296,%bp
	jnb     ex_isp_hl1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      ex_isp_hl1_mid
	cmpl    $86,%edi
	jle     ex_isp_hl1_mid
	subl    $2,%edi

ex_isp_hl1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      ex_isp_hl2_mid
	movb    %dl,(%ebp)
	cmpw    $23296,%bp
	jnb     ex_isp_hl2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      ex_isp_hl2_mid
	cmpl    $86,%edi
	jle     ex_isp_hl2_mid
	subl    $2,%edi

ex_isp_hl2_mid:

ex_isp_hl_end:
	movw    %ax,%dx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ex_isp_ix:
	movb    (%ebp),%al
	incw    %bp
	movb    (%ebp),%ah
	incw    %bp
	xchgw   z80_proc+20,%dx
	cmpw    $23297,%bp
	jb      ex_isp_ix_cmpx
	decw    %bp
	movb    %dh,(%ebp)
	decw    %bp
	movb    %dl,(%ebp)
	jmp     ex_isp_ix_end
	.align  4

ex_isp_ix_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      ex_isp_ix1_mid
	movb    %dh,(%ebp)
	cmpw    $23296,%bp
	jnb     ex_isp_ix1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      ex_isp_ix1_mid
	cmpl    $86,%edi
	jle     ex_isp_ix1_mid
	subl    $2,%edi

ex_isp_ix1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      ex_isp_ix2_mid
	movb    %dl,(%ebp)
	cmpw    $23296,%bp
	jnb     ex_isp_ix2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      ex_isp_ix2_mid
	cmpl    $86,%edi
	jle     ex_isp_ix2_mid
	subl    $2,%edi

ex_isp_ix2_mid:

ex_isp_ix_end:
	movw    %ax,%dx
	xchgw   z80_proc+20,%dx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ex_isp_iy:
	movb    (%ebp),%al
	incw    %bp
	movb    (%ebp),%ah
	incw    %bp
	xchgw   z80_proc+24,%dx
	cmpw    $23297,%bp
	jb      ex_isp_iy_cmpx
	decw    %bp
	movb    %dh,(%ebp)
	decw    %bp
	movb    %dl,(%ebp)
	jmp     ex_isp_iy_end
	.align  4

ex_isp_iy_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      ex_isp_iy1_mid
	movb    %dh,(%ebp)
	cmpw    $23296,%bp
	jnb     ex_isp_iy1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      ex_isp_iy1_mid
	cmpl    $86,%edi
	jle     ex_isp_iy1_mid
	subl    $2,%edi

ex_isp_iy1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      ex_isp_iy2_mid
	movb    %dl,(%ebp)
	cmpw    $23296,%bp
	jnb     ex_isp_iy2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      ex_isp_iy2_mid
	cmpl    $86,%edi
	jle     ex_isp_iy2_mid
	subl    $2,%edi

ex_isp_iy2_mid:

ex_isp_iy_end:
	movw    %ax,%dx
	xchgw   z80_proc+24,%dx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ex_de_hl:
	xchgw   z80_proc+4,%dx
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

di:
	movw    $0,z80_proc+60
	movw    $0,z80_proc+64
	cmpw    $1370,%si
	je      load_point

di_check_end:
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ei:
	movw    $1,z80_proc+60
	movw    $1,z80_proc+64
	incl    z80_proc+76
	subl    $4,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

call_cc_nn:

call_nn:
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	xchgw   %si,%dx
	cmpw    $23297,%bp
	jb      call_nn_cmpx
	decw    %bp
	movb    %dh,(%ebp)
	decw    %bp
	movb    %dl,(%ebp)
	jmp     call_nn_end
	.align  4

call_nn_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      call_nn1_mid
	movb    %dh,(%ebp)
	cmpw    $23296,%bp
	jnb     call_nn1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      call_nn1_mid
	cmpl    $86,%edi
	jle     call_nn1_mid
	subl    $2,%edi

call_nn1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      call_nn2_mid
	movb    %dl,(%ebp)
	cmpw    $23296,%bp
	jnb     call_nn2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      call_nn2_mid
	cmpl    $86,%edi
	jle     call_nn2_mid
	subl    $2,%edi

call_nn2_mid:

call_nn_end:
	xchgw   %si,%dx
	movw    %ax,%si
	incl    z80_proc+76
	subl    $17,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

call_nz_nn:
	testb   $64,%cl
	jz      call_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

call_z_nn:
	testb   $64,%cl
	jnz     call_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

call_nc_nn:
	testb   $1,%cl
	jz      call_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

call_c_nn:
	testb   $1,%cl
	jnz     call_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

call_po_nn:
	testb   $4,%cl
	jz      call_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

call_pe_nn:
	testb   $4,%cl
	jnz     call_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

call_p_nn:
	testb   $128,%cl
	jz      call_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

call_m_nn:
	testb   $128,%cl
	jnz     call_cc_nn
	incw    %si
	incw    %si
	incl    z80_proc+76
	subl    $10,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

push_bc:
	cmpw    $23297,%bp
	jb      push_bc_cmpx
	decw    %bp
	movb    %bh,(%ebp)
	decw    %bp
	movb    %bl,(%ebp)
	jmp     push_bc_end
	.align  4

push_bc_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      push_bc1_mid
	movb    %bh,(%ebp)
	cmpw    $23296,%bp
	jnb     push_bc1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_bc1_mid
	cmpl    $86,%edi
	jle     push_bc1_mid
	subl    $2,%edi

push_bc1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      push_bc2_mid
	movb    %bl,(%ebp)
	cmpw    $23296,%bp
	jnb     push_bc2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_bc2_mid
	cmpl    $86,%edi
	jle     push_bc2_mid
	subl    $2,%edi

push_bc2_mid:

push_bc_end:
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

push_de:
	movw    z80_proc+4,%ax
	cmpw    $23297,%bp
	jb      push_de_cmpx
	decw    %bp
	movb    %ah,(%ebp)
	decw    %bp
	movb    %al,(%ebp)
	jmp     push_de_end
	.align  4

push_de_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      push_de1_mid
	movb    %ah,(%ebp)
	cmpw    $23296,%bp
	jnb     push_de1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_de1_mid
	cmpl    $86,%edi
	jle     push_de1_mid
	subl    $2,%edi

push_de1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      push_de2_mid
	movb    %al,(%ebp)
	cmpw    $23296,%bp
	jnb     push_de2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_de2_mid
	cmpl    $86,%edi
	jle     push_de2_mid
	subl    $2,%edi

push_de2_mid:

push_de_end:
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

push_hl:
	cmpw    $23297,%bp
	jb      push_hl_cmpx
	decw    %bp
	movb    %dh,(%ebp)
	decw    %bp
	movb    %dl,(%ebp)
	jmp     push_hl_end
	.align  4

push_hl_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      push_hl1_mid
	movb    %dh,(%ebp)
	cmpw    $23296,%bp
	jnb     push_hl1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_hl1_mid
	cmpl    $86,%edi
	jle     push_hl1_mid
	subl    $2,%edi

push_hl1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      push_hl2_mid
	movb    %dl,(%ebp)
	cmpw    $23296,%bp
	jnb     push_hl2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_hl2_mid
	cmpl    $86,%edi
	jle     push_hl2_mid
	subl    $2,%edi

push_hl2_mid:

push_hl_end:
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

push_ix:
	movw    z80_proc+20,%ax
	cmpw    $23297,%bp
	jb      push_ix_cmpx
	decw    %bp
	movb    %ah,(%ebp)
	decw    %bp
	movb    %al,(%ebp)
	jmp     push_ix_end
	.align  4

push_ix_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      push_ix1_mid
	movb    %ah,(%ebp)
	cmpw    $23296,%bp
	jnb     push_ix1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_ix1_mid
	cmpl    $86,%edi
	jle     push_ix1_mid
	subl    $2,%edi

push_ix1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      push_ix2_mid
	movb    %al,(%ebp)
	cmpw    $23296,%bp
	jnb     push_ix2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_ix2_mid
	cmpl    $86,%edi
	jle     push_ix2_mid
	subl    $2,%edi

push_ix2_mid:

push_ix_end:
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

push_iy:
	movw    z80_proc+24,%ax
	cmpw    $23297,%bp
	jb      push_iy_cmpx
	decw    %bp
	movb    %ah,(%ebp)
	decw    %bp
	movb    %al,(%ebp)
	jmp     push_iy_end
	.align  4

push_iy_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      push_iy1_mid
	movb    %ah,(%ebp)
	cmpw    $23296,%bp
	jnb     push_iy1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_iy1_mid
	cmpl    $86,%edi
	jle     push_iy1_mid
	subl    $2,%edi

push_iy1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      push_iy2_mid
	movb    %al,(%ebp)
	cmpw    $23296,%bp
	jnb     push_iy2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_iy2_mid
	cmpl    $86,%edi
	jle     push_iy2_mid
	subl    $2,%edi

push_iy2_mid:

push_iy_end:
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

push_af:
	cmpw    $23297,%bp
	jb      push_af_cmpx
	decw    %bp
	movb    %ch,(%ebp)
	decw    %bp
	movb    %cl,(%ebp)
	jmp     push_af_end
	.align  4

push_af_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      push_af1_mid
	movb    %ch,(%ebp)
	cmpw    $23296,%bp
	jnb     push_af1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_af1_mid
	cmpl    $86,%edi
	jle     push_af1_mid
	subl    $2,%edi

push_af1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      push_af2_mid
	movb    %cl,(%ebp)
	cmpw    $23296,%bp
	jnb     push_af2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      push_af2_mid
	cmpl    $86,%edi
	jle     push_af2_mid
	subl    $2,%edi

push_af2_mid:

push_af_end:
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

add_a_n:
	addb    (%esi),%ch
	call    addflags
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_a_n:
	movb    %cl,%ah
	sahf    
	adcb    (%esi),%ch
	call    addflags
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sub_n:
	subb    (%esi),%ch
	call    subflags
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_a_n:
	movb    %cl,%ah
	sahf    
	sbbb    (%esi),%ch
	call    subflags
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

and_n:
	andb    (%esi),%ch
	call    andflags
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

xor_n:
	xorb    (%esi),%ch
	call    orflags
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

or_n:
	orb     (%esi),%ch
	call    orflags
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cp_n:
	cmpb    (%esi),%ch
	call    subflags
	incw    %si
	incl    z80_proc+76
	subl    $7,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rst_nn:
	cmpw    $23297,%bp
	jb      rst_nn_cmpx
	decw    %bp
	movb    %ah,(%ebp)
	decw    %bp
	movb    %al,(%ebp)
	jmp     rst_nn_end
	.align  4

rst_nn_cmpx:
	decw    %bp
	testw   $49152,%bp
	jz      rst_nn1_mid
	movb    %ah,(%ebp)
	cmpw    $23296,%bp
	jnb     rst_nn1_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      rst_nn1_mid
	cmpl    $86,%edi
	jle     rst_nn1_mid
	subl    $2,%edi

rst_nn1_mid:
	decw    %bp
	testw   $49152,%bp
	jz      rst_nn2_mid
	movb    %al,(%ebp)
	cmpw    $23296,%bp
	jnb     rst_nn2_mid
	xchgw   %cx,%bp
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%bp
	cmpl    $0,z80_proc+80
	jl      rst_nn2_mid
	cmpl    $86,%edi
	jle     rst_nn2_mid
	subl    $2,%edi

rst_nn2_mid:

rst_nn_end:
	incl    z80_proc+76
	subl    $11,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rst_00:
	movw    %si,%ax
	movw    $0,%si
	jmp     rst_nn
	.align  4

rst_08:
	movw    %si,%ax
	movw    $8,%si
	jmp     rst_nn
	.align  4

rst_10:
	movw    %si,%ax
	movw    $16,%si
	jmp     rst_nn
	.align  4

rst_18:
	movw    %si,%ax
	movw    $24,%si
	jmp     rst_nn
	.align  4

rst_20:
	movw    %si,%ax
	movw    $32,%si
	jmp     rst_nn
	.align  4

rst_28:
	movw    %si,%ax
	movw    $40,%si
	jmp     rst_nn
	.align  4

rst_30:
	movw    %si,%ax
	movw    $48,%si
	jmp     rst_nn
	.align  4

rst_38:
	movw    %si,%ax
	movw    $56,%si
	jmp     rst_nn
	.align  4

in_b_ic:
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      in_RB_ic_in_active
	testb   $1,%bl
	jnz     in_RB_ic_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      in_RB_ic_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%bh
	andb    z80_proc+88,%bh
	decl    %edi
	jmp     in_RB_ic_in_end
	.align  4

in_RB_ic_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%bh
	andb    z80_proc+88,%bh
	decl    %edi
	jmp     in_RB_ic_in_end
	.align  4

in_RB_ic_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%bh
	jmp     in_RB_ic_in_end
	.align  4

in_RB_ic_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      in_RB_ic_in_ulaidle
	cmpl    $96,%edi
	jle     in_RB_ic_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%bh
	jmp     in_RB_ic_in_end

in_RB_ic_in_ulaidle:
	movb    $255,%bh
	jmp     in_RB_ic_in_end
	.align  4

in_RB_ic_in_end:
	testb   %bh,%bh
	lahf    
	andb    $41,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

in_c_ic:
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      in_RC_ic_in_active
	testb   $1,%bl
	jnz     in_RC_ic_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      in_RC_ic_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%bl
	andb    z80_proc+88,%bl
	decl    %edi
	jmp     in_RC_ic_in_end
	.align  4

in_RC_ic_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%bl
	andb    z80_proc+88,%bl
	decl    %edi
	jmp     in_RC_ic_in_end
	.align  4

in_RC_ic_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%bl
	jmp     in_RC_ic_in_end
	.align  4

in_RC_ic_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      in_RC_ic_in_ulaidle
	cmpl    $96,%edi
	jle     in_RC_ic_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%bl
	jmp     in_RC_ic_in_end

in_RC_ic_in_ulaidle:
	movb    $255,%bl
	jmp     in_RC_ic_in_end
	.align  4

in_RC_ic_in_end:
	testb   %bl,%bl
	lahf    
	andb    $41,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

in_d_ic:
	xchgb   z80_proc+5,%ch
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      in_MD_ic_in_active
	testb   $1,%bl
	jnz     in_MD_ic_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      in_MD_ic_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%ch
	andb    z80_proc+88,%ch
	decl    %edi
	jmp     in_MD_ic_in_end
	.align  4

in_MD_ic_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%ch
	andb    z80_proc+88,%ch
	decl    %edi
	jmp     in_MD_ic_in_end
	.align  4

in_MD_ic_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%ch
	jmp     in_MD_ic_in_end
	.align  4

in_MD_ic_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      in_MD_ic_in_ulaidle
	cmpl    $96,%edi
	jle     in_MD_ic_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%ch
	jmp     in_MD_ic_in_end

in_MD_ic_in_ulaidle:
	movb    $255,%ch
	jmp     in_MD_ic_in_end
	.align  4

in_MD_ic_in_end:
	testb   %ch,%ch
	lahf    
	andb    $41,%cl
	andb    $196,%ah
	orb     %ah,%cl
	xchgb   z80_proc+5,%ch
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

in_e_ic:
	xchgb   z80_proc+4,%ch
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      in_ME_ic_in_active
	testb   $1,%bl
	jnz     in_ME_ic_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      in_ME_ic_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%ch
	andb    z80_proc+88,%ch
	decl    %edi
	jmp     in_ME_ic_in_end
	.align  4

in_ME_ic_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%ch
	andb    z80_proc+88,%ch
	decl    %edi
	jmp     in_ME_ic_in_end
	.align  4

in_ME_ic_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%ch
	jmp     in_ME_ic_in_end
	.align  4

in_ME_ic_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      in_ME_ic_in_ulaidle
	cmpl    $96,%edi
	jle     in_ME_ic_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%ch
	jmp     in_ME_ic_in_end

in_ME_ic_in_ulaidle:
	movb    $255,%ch
	jmp     in_ME_ic_in_end
	.align  4

in_ME_ic_in_end:
	testb   %ch,%ch
	lahf    
	andb    $41,%cl
	andb    $196,%ah
	orb     %ah,%cl
	xchgb   z80_proc+4,%ch
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

in_h_ic:
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      in_RH_ic_in_active
	testb   $1,%bl
	jnz     in_RH_ic_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      in_RH_ic_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%dh
	andb    z80_proc+88,%dh
	decl    %edi
	jmp     in_RH_ic_in_end
	.align  4

in_RH_ic_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%dh
	andb    z80_proc+88,%dh
	decl    %edi
	jmp     in_RH_ic_in_end
	.align  4

in_RH_ic_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%dh
	jmp     in_RH_ic_in_end
	.align  4

in_RH_ic_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      in_RH_ic_in_ulaidle
	cmpl    $96,%edi
	jle     in_RH_ic_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%dh
	jmp     in_RH_ic_in_end

in_RH_ic_in_ulaidle:
	movb    $255,%dh
	jmp     in_RH_ic_in_end
	.align  4

in_RH_ic_in_end:
	testb   %dh,%dh
	lahf    
	andb    $41,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

in_l_ic:
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      in_RL_ic_in_active
	testb   $1,%bl
	jnz     in_RL_ic_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      in_RL_ic_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%dl
	andb    z80_proc+88,%dl
	decl    %edi
	jmp     in_RL_ic_in_end
	.align  4

in_RL_ic_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%dl
	andb    z80_proc+88,%dl
	decl    %edi
	jmp     in_RL_ic_in_end
	.align  4

in_RL_ic_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%dl
	jmp     in_RL_ic_in_end
	.align  4

in_RL_ic_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      in_RL_ic_in_ulaidle
	cmpl    $96,%edi
	jle     in_RL_ic_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%dl
	jmp     in_RL_ic_in_end

in_RL_ic_in_ulaidle:
	movb    $255,%dl
	jmp     in_RL_ic_in_end
	.align  4

in_RL_ic_in_end:
	testb   %dl,%dl
	lahf    
	andb    $41,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

in_f_ic:
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      in_RW_ic_in_active
	testb   $1,%bl
	jnz     in_RW_ic_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      in_RW_ic_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     in_RW_ic_in_end
	.align  4

in_RW_ic_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     in_RW_ic_in_end
	.align  4

in_RW_ic_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%al
	jmp     in_RW_ic_in_end
	.align  4

in_RW_ic_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      in_RW_ic_in_ulaidle
	cmpl    $96,%edi
	jle     in_RW_ic_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%al
	jmp     in_RW_ic_in_end

in_RW_ic_in_ulaidle:
	movb    $255,%al
	jmp     in_RW_ic_in_end
	.align  4

in_RW_ic_in_end:
	testb   %al,%al
	lahf    
	andb    $41,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

in_a_ic:
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      in_RA_ic_in_active
	testb   $1,%bl
	jnz     in_RA_ic_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      in_RA_ic_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%ch
	andb    z80_proc+88,%ch
	decl    %edi
	jmp     in_RA_ic_in_end
	.align  4

in_RA_ic_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%ch
	andb    z80_proc+88,%ch
	decl    %edi
	jmp     in_RA_ic_in_end
	.align  4

in_RA_ic_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%ch
	jmp     in_RA_ic_in_end
	.align  4

in_RA_ic_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      in_RA_ic_in_ulaidle
	cmpl    $96,%edi
	jle     in_RA_ic_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%ch
	jmp     in_RA_ic_in_end

in_RA_ic_in_ulaidle:
	movb    $255,%ch
	jmp     in_RA_ic_in_end
	.align  4

in_RA_ic_in_end:
	testb   %ch,%ch
	lahf    
	andb    $41,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

out_ic_b:
	testb   $1,%bl
	jnz     out_ic_RB_out_nonfe
	movb    %bh,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %bh,z80_proc+92
	testb   $16,%ah
	jz      out_ic_RB_out_end
	movl    $1,z80_proc+100
	testb   $16,%bh
	jz      out_ic_RB_out_s_0
	addl    %edi,z80_proc+96
	jmp     out_ic_RB_out_end
	.align  4

out_ic_RB_out_s_0:
	subl    %edi,z80_proc+96
	jmp     out_ic_RB_out_end
	.align  4

out_ic_RB_out_nonfe:
	movzbl  %bl,%eax
	movb    %bh,z80_outports(%eax)

out_ic_RB_out_end:
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

out_ic_c:
	testb   $1,%bl
	jnz     out_ic_RC_out_nonfe
	movb    %bl,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %bl,z80_proc+92
	testb   $16,%ah
	jz      out_ic_RC_out_end
	movl    $1,z80_proc+100
	testb   $16,%bl
	jz      out_ic_RC_out_s_0
	addl    %edi,z80_proc+96
	jmp     out_ic_RC_out_end
	.align  4

out_ic_RC_out_s_0:
	subl    %edi,z80_proc+96
	jmp     out_ic_RC_out_end
	.align  4

out_ic_RC_out_nonfe:
	movzbl  %bl,%eax
	movb    %bl,z80_outports(%eax)

out_ic_RC_out_end:
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

out_ic_d:
	xchgb   z80_proc+5,%ch
	testb   $1,%bl
	jnz     out_ic_MD_out_nonfe
	movb    %ch,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %ch,z80_proc+92
	testb   $16,%ah
	jz      out_ic_MD_out_end
	movl    $1,z80_proc+100
	testb   $16,%ch
	jz      out_ic_MD_out_s_0
	addl    %edi,z80_proc+96
	jmp     out_ic_MD_out_end
	.align  4

out_ic_MD_out_s_0:
	subl    %edi,z80_proc+96
	jmp     out_ic_MD_out_end
	.align  4

out_ic_MD_out_nonfe:
	movzbl  %bl,%eax
	movb    %ch,z80_outports(%eax)

out_ic_MD_out_end:
	xchgb   z80_proc+5,%ch
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

out_ic_e:
	xchgb   z80_proc+4,%ch
	testb   $1,%bl
	jnz     out_ic_ME_out_nonfe
	movb    %ch,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %ch,z80_proc+92
	testb   $16,%ah
	jz      out_ic_ME_out_end
	movl    $1,z80_proc+100
	testb   $16,%ch
	jz      out_ic_ME_out_s_0
	addl    %edi,z80_proc+96
	jmp     out_ic_ME_out_end
	.align  4

out_ic_ME_out_s_0:
	subl    %edi,z80_proc+96
	jmp     out_ic_ME_out_end
	.align  4

out_ic_ME_out_nonfe:
	movzbl  %bl,%eax
	movb    %ch,z80_outports(%eax)

out_ic_ME_out_end:
	xchgb   z80_proc+4,%ch
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

out_ic_h:
	testb   $1,%bl
	jnz     out_ic_RH_out_nonfe
	movb    %dh,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %dh,z80_proc+92
	testb   $16,%ah
	jz      out_ic_RH_out_end
	movl    $1,z80_proc+100
	testb   $16,%dh
	jz      out_ic_RH_out_s_0
	addl    %edi,z80_proc+96
	jmp     out_ic_RH_out_end
	.align  4

out_ic_RH_out_s_0:
	subl    %edi,z80_proc+96
	jmp     out_ic_RH_out_end
	.align  4

out_ic_RH_out_nonfe:
	movzbl  %bl,%eax
	movb    %dh,z80_outports(%eax)

out_ic_RH_out_end:
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

out_ic_l:
	testb   $1,%bl
	jnz     out_ic_RL_out_nonfe
	movb    %dl,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %dl,z80_proc+92
	testb   $16,%ah
	jz      out_ic_RL_out_end
	movl    $1,z80_proc+100
	testb   $16,%dl
	jz      out_ic_RL_out_s_0
	addl    %edi,z80_proc+96
	jmp     out_ic_RL_out_end
	.align  4

out_ic_RL_out_s_0:
	subl    %edi,z80_proc+96
	jmp     out_ic_RL_out_end
	.align  4

out_ic_RL_out_nonfe:
	movzbl  %bl,%eax
	movb    %dl,z80_outports(%eax)

out_ic_RL_out_end:
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

out_ic_0:
	xorb    %al,%al
	testb   $1,%bl
	jnz     out_ic_RW_out_nonfe
	movb    %al,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %al,z80_proc+92
	testb   $16,%ah
	jz      out_ic_RW_out_end
	movl    $1,z80_proc+100
	testb   $16,%al
	jz      out_ic_RW_out_s_0
	addl    %edi,z80_proc+96
	jmp     out_ic_RW_out_end
	.align  4

out_ic_RW_out_s_0:
	subl    %edi,z80_proc+96
	jmp     out_ic_RW_out_end
	.align  4

out_ic_RW_out_nonfe:
	movzbl  %bl,%eax
	movb    %al,z80_outports(%eax)

out_ic_RW_out_end:
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

out_ic_a:
	testb   $1,%bl
	jnz     out_ic_RA_out_nonfe
	movb    %ch,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %ch,z80_proc+92
	testb   $16,%ah
	jz      out_ic_RA_out_end
	movl    $1,z80_proc+100
	testb   $16,%ch
	jz      out_ic_RA_out_s_0
	addl    %edi,z80_proc+96
	jmp     out_ic_RA_out_end
	.align  4

out_ic_RA_out_s_0:
	subl    %edi,z80_proc+96
	jmp     out_ic_RA_out_end
	.align  4

out_ic_RA_out_nonfe:
	movzbl  %bl,%eax
	movb    %ch,z80_outports(%eax)

out_ic_RA_out_end:
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_hl_bc:
	movb    %cl,%ah
	sahf    
	sbbb    %bl,%dl
	sbbb    %bh,%dh
	pushfl  
	testw   %dx,%dx
	lahf    
	orb     $215,%cl
	orb     $191,%ah
	andb    %ah,%cl
	popfl   
	lahf    
	setno   %al
	orb     $145,%cl
	orb     $110,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_hl_de:
	movb    %cl,%ah
	sahf    
	sbbb    z80_proc+4,%dl
	sbbb    z80_proc+5,%dh
	pushfl  
	testw   %dx,%dx
	lahf    
	orb     $215,%cl
	orb     $191,%ah
	andb    %ah,%cl
	popfl   
	lahf    
	setno   %al
	orb     $145,%cl
	orb     $110,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_hl_hl:
	movb    %cl,%ah
	sahf    
	sbbb    %dl,%dl
	sbbb    %dh,%dh
	pushfl  
	testw   %dx,%dx
	lahf    
	orb     $215,%cl
	orb     $191,%ah
	andb    %ah,%cl
	popfl   
	lahf    
	setno   %al
	orb     $145,%cl
	orb     $110,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sbc_hl_sp:
	movb    %cl,%ah
	sahf    
	movw    %bp,%ax
	sbbb    %al,%dl
	sbbb    %ah,%dh
	pushfl  
	testw   %dx,%dx
	lahf    
	orb     $215,%cl
	orb     $191,%ah
	andb    %ah,%cl
	popfl   
	lahf    
	setno   %al
	orb     $145,%cl
	orb     $110,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_hl_bc:
	movb    %cl,%ah
	sahf    
	adcb    %bl,%dl
	adcb    %bh,%dh
	pushfl  
	testw   %dx,%dx
	lahf    
	andb    $40,%cl
	andb    $64,%ah
	orb     %ah,%cl
	popfl   
	lahf    
	seto    %al
	andb    $110,%cl
	andb    $145,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_hl_de:
	movb    %cl,%ah
	sahf    
	adcb    z80_proc+4,%dl
	adcb    z80_proc+5,%dh
	pushfl  
	testw   %dx,%dx
	lahf    
	andb    $40,%cl
	andb    $64,%ah
	orb     %ah,%cl
	popfl   
	lahf    
	seto    %al
	andb    $110,%cl
	andb    $145,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_hl_hl:
	movb    %cl,%ah
	sahf    
	adcb    %dl,%dl
	adcb    %dh,%dh
	pushfl  
	testw   %dx,%dx
	lahf    
	andb    $40,%cl
	andb    $64,%ah
	orb     %ah,%cl
	popfl   
	lahf    
	seto    %al
	andb    $110,%cl
	andb    $145,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

adc_hl_sp:
	movw    %bp,%ax
	movb    %cl,%ah
	sahf    
	adcb    %al,%dl
	adcb    %ah,%dh
	pushfl  
	testw   %dx,%dx
	lahf    
	andb    $40,%cl
	andb    $64,%ah
	orb     %ah,%cl
	popfl   
	lahf    
	seto    %al
	andb    $110,%cl
	andb    $145,%ah
	orb     %ah,%cl
	shlb    $2,%al
	orb     %al,%cl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_bc:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	testb   $192,%ah
	jz      ld_inn1_bc_mid
	movb    %bl,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn1_bc_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn1_bc_mid
	cmpl    $86,%edi
	jle     ld_inn1_bc_mid
	subl    $2,%edi

ld_inn1_bc_mid:
	incw    %ax
	testb   $192,%ah
	jz      ld_inn2_bc_mid
	movb    %bh,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn2_bc_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn2_bc_mid
	cmpl    $86,%edi
	jle     ld_inn2_bc_mid
	subl    $2,%edi

ld_inn2_bc_mid:
	incl    z80_proc+76
	subl    $20,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_de:
	xchgw   z80_proc+4,%dx
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	testb   $192,%ah
	jz      ld_inn1_de_mid
	movb    %dl,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn1_de_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn1_de_mid
	cmpl    $86,%edi
	jle     ld_inn1_de_mid
	subl    $2,%edi

ld_inn1_de_mid:
	incw    %ax
	testb   $192,%ah
	jz      ld_inn2_de_mid
	movb    %dh,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn2_de_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn2_de_mid
	cmpl    $86,%edi
	jle     ld_inn2_de_mid
	subl    $2,%edi

ld_inn2_de_mid:
	xchgw   z80_proc+4,%dx
	incl    z80_proc+76
	subl    $20,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_hl_ed:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	testb   $192,%ah
	jz      ld_inn1_hl_mid
	movb    %dl,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn1_hl_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn1_hl_mid
	cmpl    $86,%edi
	jle     ld_inn1_hl_mid
	subl    $2,%edi

ld_inn1_hl_mid:
	incw    %ax
	testb   $192,%ah
	jz      ld_inn2_hl_mid
	movb    %dh,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn2_hl_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn2_hl_mid
	cmpl    $86,%edi
	jle     ld_inn2_hl_mid
	subl    $2,%edi

ld_inn2_hl_mid:
	incl    z80_proc+76
	subl    $20,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_inn_sp:
	xchgw   %bp,%dx
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	testb   $192,%ah
	jz      ld_inn1_sp_mid
	movb    %dl,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn1_sp_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn1_sp_mid
	cmpl    $86,%edi
	jle     ld_inn1_sp_mid
	subl    $2,%edi

ld_inn1_sp_mid:
	incw    %ax
	testb   $192,%ah
	jz      ld_inn2_sp_mid
	movb    %dh,(%eax)
	cmpb    $91,%ah
	jnb     ld_inn2_sp_mid
	xchgw   %cx,%ax
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%ax
	cmpl    $0,z80_proc+80
	jl      ld_inn2_sp_mid
	cmpl    $86,%edi
	jle     ld_inn2_sp_mid
	subl    $2,%edi

ld_inn2_sp_mid:
	xchgw   %bp,%dx
	incl    z80_proc+76
	subl    $20,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_bc_inn:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movb    (%eax),%bl
	incw    %ax
	movb    (%eax),%bh
	incl    z80_proc+76
	subl    $20,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_de_inn:
	xchgw   z80_proc+4,%dx
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movb    (%eax),%dl
	incw    %ax
	movb    (%eax),%dh
	xchgw   z80_proc+4,%dx
	incl    z80_proc+76
	subl    $20,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_hl_inn_ed:
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movb    (%eax),%dl
	incw    %ax
	movb    (%eax),%dh
	incl    z80_proc+76
	subl    $20,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_sp_inn:
	xchgw   %bp,%dx
	movl    %edx,%eax
	movb    (%esi),%al
	incw    %si
	movb    (%esi),%ah
	incw    %si
	movb    (%eax),%dl
	incw    %ax
	movb    (%eax),%dh
	xchgw   %bp,%dx
	incl    z80_proc+76
	subl    $20,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

neg:
	negb    %ch
	call    subflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

retn:
	movl    z80_proc+64,%eax
	movl    %eax,z80_proc+60
	movb    (%ebp),%al
	incw    %bp
	movb    (%ebp),%ah
	incw    %bp
	movw    %ax,%si
	incl    z80_proc+76
	subl    $14,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

reti:
	movb    (%ebp),%al
	incw    %bp
	movb    (%ebp),%ah
	incw    %bp
	movw    %ax,%si
	incl    z80_proc+76
	subl    $14,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

im_0:
	movl    $0,z80_proc+56
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

im_1:
	movl    $1,z80_proc+56
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

im_2:
	movl    $2,z80_proc+56
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_i_a:
	movb    %ch,z80_proc+17
	incl    z80_proc+76
	subl    $9,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_r_a:
	movb    %ch,z80_proc+76
	movb    %ch,%al
	andb    $128,%al
	movb    %al,z80_proc+16
	incl    z80_proc+76
	subl    $9,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_air_end:
	andb    $251,%cl
	incl    z80_proc+76
	subl    $9,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ld_a_i:
	movb    z80_proc+17,%ch
	testb   %ch,%ch
	lahf    
	andb    $41,%cl
	andb    $192,%ah
	orb     %ah,%cl
	movl    z80_proc+64,%eax
	testl   %eax,%eax
	jz      ld_air_end
	orb     $4,%cl
	incl    z80_proc+76
	subl    $9,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4
	.align  4

ld_a_r:
	movb    z80_proc+16,%ch
	movb    z80_proc+76,%al
	andb    $127,%al
	orb     %al,%ch
	testb   %ch,%ch
	lahf    
	andb    $41,%cl
	andb    $192,%ah
	orb     %ah,%cl
	movl    z80_proc+64,%eax
	testl   %eax,%eax
	jz      ld_air_end
	orb     $4,%cl
	incl    z80_proc+76
	subl    $9,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4
	.align  4

rrd:
	movb    %ch,%ah
	movb    (%edx),%al
	shlw    $4,%ax
	shrb    $4,%al
	andb    $240,%ch
	orb     %al,%ch
	movb    %ah,%al
	lahf    
	andb    $41,%cl
	andb    $196,%ah
	orb     %ah,%cl
	cmpb    $91,%dh
	jb      rrd_scr
	movb    %al,(%edx)
	incl    z80_proc+76
	subl    $18,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrd_scr:
	testb   $192,%dh
	jz      rrd_rom
	movb    %al,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      rrd_rom
	cmpl    $86,%edi
	jle     rrd_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $18,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrd_rom:
	incl    z80_proc+76
	subl    $18,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rld:
	movb    %ch,%al
	movb    (%edx),%ah
	shlb    $4,%al
	shrw    $4,%ax
	andb    $240,%ch
	orb     %ah,%ch
	lahf    
	andb    $41,%cl
	andb    $196,%ah
	orb     %ah,%cl
	cmpb    $91,%dh
	jb      rld_scr
	movb    %al,(%edx)
	incl    z80_proc+76
	subl    $18,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rld_scr:
	testb   $192,%dh
	jz      rld_rom
	movb    %al,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      rld_rom
	cmpl    $86,%edi
	jle     rld_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $18,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rld_rom:
	incl    z80_proc+76
	subl    $18,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ldid:
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ldi:
	movb    (%edx),%al
	xchgw   %dx,z80_proc+4
	testb   $192,%dh
	jz      ldi_mid
	movb    %al,(%edx)
	cmpb    $91,%dh
	jnb     ldi_mid
	xchgw   %cx,%dx
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%dx
	cmpl    $0,z80_proc+80
	jl      ldi_mid
	cmpl    $86,%edi
	jle     ldi_mid
	subl    $2,%edi

ldi_mid:
	incw    %dx
	xchgw   %dx,z80_proc+4
	incw    %dx
	andb    $233,%cl
	decw    %bx
	jz      ldid
	orb     $4,%cl
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ldir:
	movb    (%edx),%al
	xchgw   %dx,z80_proc+4
	testb   $192,%dh
	jz      ldir_mid
	movb    %al,(%edx)
	cmpb    $91,%dh
	jnb     ldir_mid
	xchgw   %cx,%dx
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%dx
	cmpl    $0,z80_proc+80
	jl      ldir_mid
	cmpl    $86,%edi
	jle     ldir_mid
	subl    $2,%edi

ldir_mid:
	incw    %dx
	xchgw   %dx,z80_proc+4
	incw    %dx
	andb    $233,%cl
	decw    %bx
	jz      ldid
	orb     $4,%cl
	subw    $2,%si
	incl    z80_proc+76
	subl    $21,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ldd:
	movb    (%edx),%al
	xchgw   %dx,z80_proc+4
	testb   $192,%dh
	jz      ldd_mid
	movb    %al,(%edx)
	cmpb    $91,%dh
	jnb     ldd_mid
	xchgw   %cx,%dx
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%dx
	cmpl    $0,z80_proc+80
	jl      ldd_mid
	cmpl    $86,%edi
	jle     ldd_mid
	subl    $2,%edi

ldd_mid:
	decw    %dx
	xchgw   %dx,z80_proc+4
	decw    %dx
	andb    $233,%cl
	decw    %bx
	jz      ldid
	orb     $4,%cl
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

lddr:
	movb    (%edx),%al
	xchgw   %dx,z80_proc+4
	testb   $192,%dh
	jz      lddr_mid
	movb    %al,(%edx)
	cmpb    $91,%dh
	jnb     lddr_mid
	xchgw   %cx,%dx
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%dx
	cmpl    $0,z80_proc+80
	jl      lddr_mid
	cmpl    $86,%edi
	jle     lddr_mid
	subl    $2,%edi

lddr_mid:
	decw    %dx
	xchgw   %dx,z80_proc+4
	decw    %dx
	andb    $233,%cl
	decw    %bx
	jz      ldid
	orb     $4,%cl
	subw    $2,%si
	incl    z80_proc+76
	subl    $21,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cpid:
	andb    $251,%cl
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cpi:
	cmpb    (%edx),%ch
	lahf    
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	incw    %dx
	decw    %bx
	jz      cpid
	testb   $64,%cl
	jnz     ldid
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cpir:
	cmpb    (%edx),%ch
	lahf    
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	incw    %dx
	decw    %bx
	jz      cpid
	testb   $64,%cl
	jnz     ldid
	subw    $2,%si
	incl    z80_proc+76
	subl    $21,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cpd:
	cmpb    (%edx),%ch
	lahf    
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	decw    %dx
	decw    %bx
	jz      cpid
	testb   $64,%cl
	jnz     ldid
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

cpdr:
	cmpb    (%edx),%ch
	lahf    
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	decw    %dx
	decw    %bx
	jz      cpid
	testb   $64,%cl
	jnz     ldid
	subw    $2,%si
	incl    z80_proc+76
	subl    $21,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ini:
	decb    %bh
	lahf    
	setno   %al
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      ini_in_active
	testb   $1,%bl
	jnz     ini_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      ini_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     ini_in_end
	.align  4

ini_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     ini_in_end
	.align  4

ini_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%al
	jmp     ini_in_end
	.align  4

ini_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      ini_in_ulaidle
	cmpl    $96,%edi
	jle     ini_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%al
	jmp     ini_in_end

ini_in_ulaidle:
	movb    $255,%al
	jmp     ini_in_end
	.align  4

ini_in_end:
	testb   $192,%dh
	jz      ini_mid
	movb    %al,(%edx)
	cmpb    $91,%dh
	jnb     ini_mid
	xchgw   %cx,%dx
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%dx
	cmpl    $0,z80_proc+80
	jl      ini_mid
	cmpl    $86,%edi
	jle     ini_mid
	subl    $2,%edi

ini_mid:
	incw    %dx
	testb   %bh,%bh
	jz      ldid
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

inir:
	decb    %bh
	lahf    
	setno   %al
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      inir_in_active
	testb   $1,%bl
	jnz     inir_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      inir_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     inir_in_end
	.align  4

inir_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     inir_in_end
	.align  4

inir_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%al
	jmp     inir_in_end
	.align  4

inir_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      inir_in_ulaidle
	cmpl    $96,%edi
	jle     inir_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%al
	jmp     inir_in_end

inir_in_ulaidle:
	movb    $255,%al
	jmp     inir_in_end
	.align  4

inir_in_end:
	testb   $192,%dh
	jz      inir_mid
	movb    %al,(%edx)
	cmpb    $91,%dh
	jnb     inir_mid
	xchgw   %cx,%dx
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%dx
	cmpl    $0,z80_proc+80
	jl      inir_mid
	cmpl    $86,%edi
	jle     inir_mid
	subl    $2,%edi

inir_mid:
	incw    %dx
	testb   %bh,%bh
	jz      ldid
	subw    $2,%si
	incl    z80_proc+76
	subl    $21,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ind:
	decb    %bh
	lahf    
	setno   %al
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      ind_in_active
	testb   $1,%bl
	jnz     ind_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      ind_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     ind_in_end
	.align  4

ind_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     ind_in_end
	.align  4

ind_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%al
	jmp     ind_in_end
	.align  4

ind_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      ind_in_ulaidle
	cmpl    $96,%edi
	jle     ind_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%al
	jmp     ind_in_end

ind_in_ulaidle:
	movb    $255,%al
	jmp     ind_in_end
	.align  4

ind_in_end:
	testb   $192,%dh
	jz      ind_mid
	movb    %al,(%edx)
	cmpb    $91,%dh
	jnb     ind_mid
	xchgw   %cx,%dx
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%dx
	cmpl    $0,z80_proc+80
	jl      ind_mid
	cmpl    $86,%edi
	jle     ind_mid
	subl    $2,%edi

ind_mid:
	decw    %dx
	testb   %bh,%bh
	jz      ldid
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

indr:
	decb    %bh
	lahf    
	setno   %al
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      indr_in_active
	testb   $1,%bl
	jnz     indr_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      indr_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     indr_in_end
	.align  4

indr_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     indr_in_end
	.align  4

indr_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%al
	jmp     indr_in_end
	.align  4

indr_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      indr_in_ulaidle
	cmpl    $96,%edi
	jle     indr_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%al
	jmp     indr_in_end

indr_in_ulaidle:
	movb    $255,%al
	jmp     indr_in_end
	.align  4

indr_in_end:
	testb   $192,%dh
	jz      indr_mid
	movb    %al,(%edx)
	cmpb    $91,%dh
	jnb     indr_mid
	xchgw   %cx,%dx
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%dx
	cmpl    $0,z80_proc+80
	jl      indr_mid
	cmpl    $86,%edi
	jle     indr_mid
	subl    $2,%edi

indr_mid:
	decw    %dx
	testb   %bh,%bh
	jz      ldid
	subw    $2,%si
	incl    z80_proc+76
	subl    $21,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

outi:
	decb    %bh
	lahf    
	setno   %al
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	movb    (%edx),%al
	testb   $1,%bl
	jnz     outi_out_nonfe
	movb    %al,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %al,z80_proc+92
	testb   $16,%ah
	jz      outi_out_end
	movl    $1,z80_proc+100
	testb   $16,%al
	jz      outi_out_s_0
	addl    %edi,z80_proc+96
	jmp     outi_out_end
	.align  4

outi_out_s_0:
	subl    %edi,z80_proc+96
	jmp     outi_out_end
	.align  4

outi_out_nonfe:
	movzbl  %bl,%eax
	movb    %al,z80_outports(%eax)

outi_out_end:
	incw    %dx
	testb   %bh,%bh
	jz      ldid
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

otir:
	decb    %bh
	lahf    
	setno   %al
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	movb    (%edx),%al
	testb   $1,%bl
	jnz     otir_out_nonfe
	movb    %al,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %al,z80_proc+92
	testb   $16,%ah
	jz      otir_out_end
	movl    $1,z80_proc+100
	testb   $16,%al
	jz      otir_out_s_0
	addl    %edi,z80_proc+96
	jmp     otir_out_end
	.align  4

otir_out_s_0:
	subl    %edi,z80_proc+96
	jmp     otir_out_end
	.align  4

otir_out_nonfe:
	movzbl  %bl,%eax
	movb    %al,z80_outports(%eax)

otir_out_end:
	incw    %dx
	testb   %bh,%bh
	jz      ldid
	subw    $2,%si
	incl    z80_proc+76
	subl    $21,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

outd:
	decb    %bh
	lahf    
	setno   %al
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	movb    (%edx),%al
	testb   $1,%bl
	jnz     outd_out_nonfe
	movb    %al,%ah
	xorb    z80_proc+92,%ah
	decl    %edi
	movb    %al,z80_proc+92
	testb   $16,%ah
	jz      outd_out_end
	movl    $1,z80_proc+100
	testb   $16,%al
	jz      outd_out_s_0
	addl    %edi,z80_proc+96
	jmp     outd_out_end
	.align  4

outd_out_s_0:
	subl    %edi,z80_proc+96
	jmp     outd_out_end
	.align  4

outd_out_nonfe:
	movzbl  %bl,%eax
	movb    %al,z80_outports(%eax)

outd_out_end:
	decw    %dx
	testb   %bh,%bh
	jz      ldid
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

otdr:
	decb    %bh
	lahf    
	setno   %al
	orb     $214,%cl
	orb     $47,%ah
	andb    %ah,%cl
	shlb    $2,%al
	notb    %al
	andb    %al,%cl
	movl    z80_proc+84,%eax
	testb   %al,%bl
	jz      otdr_in_active
	testb   $1,%bl
	jnz     otdr_in_ulabus
	cmpl    %edi,z80_proc+104
	jg      otdr_in_imp
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     otdr_in_end
	.align  4

otdr_in_imp:
	movl    $0,z80_proc+104
	xorb    $64,z80_proc+88
	movzbl  %bh,%eax
	movb    sp_fe_inport_high(%eax),%al
	andb    z80_proc+88,%al
	decl    %edi
	jmp     otdr_in_end
	.align  4

otdr_in_active:
	movzbl  %bl,%eax
	movb    z80_inports(%eax),%al
	jmp     otdr_in_end
	.align  4

otdr_in_ulabus:
	movl    %esi,%eax
	movw    z80_proc+80,%ax
	cmpw    $0,%ax
	jl      otdr_in_ulaidle
	cmpl    $96,%edi
	jle     otdr_in_ulaidle
	pushl   %edi
	shrw    $2,%di
	shlw    $5,%ax
	addw    $56,%ax
	subw    %di,%ax
	popl    %edi
	movb    (%eax),%al
	jmp     otdr_in_end

otdr_in_ulaidle:
	movb    $255,%al
	jmp     otdr_in_end
	.align  4

otdr_in_end:
	testb   $192,%dh
	jz      otdr_mid
	movb    %al,(%edx)
	cmpb    $91,%dh
	jnb     otdr_mid
	xchgw   %cx,%dx
	btsl    %ecx,sp_scr_mark
	xchgw   %cx,%dx
	cmpl    $0,z80_proc+80
	jl      otdr_mid
	cmpl    $86,%edi
	jle     otdr_mid
	subl    $2,%edi

otdr_mid:
	decw    %dx
	testb   %bh,%bh
	jz      ldid
	subw    $2,%si
	incl    z80_proc+76
	subl    $21,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

ill_ed:
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4
	.align  4

bitflags:
	lahf    
	andb    $128,%al
	andb    $61,%cl
	andb    $64,%ah
	orb     %ah,%cl
	orb     %al,%cl
	ret     
	.align  4

rotshflags:
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	testb   %al,%al
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	ret     
	.align  4

rlc_b:
	rolb    %bh
	movb    %bh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rlc_c:
	rolb    %bl
	movb    %bl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rlc_d:
	rolb    z80_proc+5
	movb    z80_proc+5,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rlc_e:
	rolb    z80_proc+4
	movb    z80_proc+4,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rlc_h:
	rolb    %dh
	movb    %dh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rlc_l:
	rolb    %dl
	movb    %dl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rlc_ihl:
	cmpb    $91,%dh
	jb      RLC_R_scr
	rolb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RLC_R_scr:
	testb   $192,%dh
	jz      RLC_R_rom
	rolb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      RLC_R_rend
	cmpl    $86,%edi
	jle     RLC_R_rend
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RLC_R_rom:
	movb    (%edx),%al
	rolb    %al
	movb    %al,%al
	call    rotshflags

RLC_R_rend:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rlc_id:
	cmpb    $91,%dh
	jb      RLC_Rid_scr
	rolb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RLC_Rid_scr:
	testb   $192,%dh
	jz      RLC_Rid_rom
	rolb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      RLC_Rid_rend
	cmpl    $86,%edi
	jle     RLC_Rid_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RLC_Rid_rom:
	movb    (%edx),%al
	rolb    %al
	movb    %al,%al
	call    rotshflags

RLC_Rid_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rlc_a:
	rolb    %ch
	movb    %ch,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrc_b:
	rorb    %bh
	movb    %bh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrc_c:
	rorb    %bl
	movb    %bl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrc_d:
	rorb    z80_proc+5
	movb    z80_proc+5,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrc_e:
	rorb    z80_proc+4
	movb    z80_proc+4,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrc_h:
	rorb    %dh
	movb    %dh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrc_l:
	rorb    %dl
	movb    %dl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrc_ihl:
	cmpb    $91,%dh
	jb      RRC_R_scr
	rorb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RRC_R_scr:
	testb   $192,%dh
	jz      RRC_R_rom
	rorb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      RRC_R_rend
	cmpl    $86,%edi
	jle     RRC_R_rend
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RRC_R_rom:
	movb    (%edx),%al
	rorb    %al
	movb    %al,%al
	call    rotshflags

RRC_R_rend:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrc_id:
	cmpb    $91,%dh
	jb      RRC_Rid_scr
	rorb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RRC_Rid_scr:
	testb   $192,%dh
	jz      RRC_Rid_rom
	rorb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      RRC_Rid_rend
	cmpl    $86,%edi
	jle     RRC_Rid_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RRC_Rid_rom:
	movb    (%edx),%al
	rorb    %al
	movb    %al,%al
	call    rotshflags

RRC_Rid_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rrc_a:
	rorb    %ch
	movb    %ch,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rl_b:
	movb    %cl,%ah
	sahf    
	rclb    %bh
	movb    %bh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rl_c:
	movb    %cl,%ah
	sahf    
	rclb    %bl
	movb    %bl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rl_d:
	movb    %cl,%ah
	sahf    
	rclb    z80_proc+5
	movb    z80_proc+5,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rl_e:
	movb    %cl,%ah
	sahf    
	rclb    z80_proc+4
	movb    z80_proc+4,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rl_h:
	movb    %cl,%ah
	sahf    
	rclb    %dh
	movb    %dh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rl_l:
	movb    %cl,%ah
	sahf    
	rclb    %dl
	movb    %dl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rl_ihl:
	cmpb    $91,%dh
	jb      RL_R_scr
	movb    %cl,%ah
	sahf    
	rclb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RL_R_scr:
	testb   $192,%dh
	jz      RL_R_rom
	movb    %cl,%ah
	sahf    
	rclb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      RL_R_rend
	cmpl    $86,%edi
	jle     RL_R_rend
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RL_R_rom:
	movb    (%edx),%al
	movb    %cl,%ah
	sahf    
	rclb    %al
	movb    %al,%al
	call    rotshflags

RL_R_rend:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rl_id:
	cmpb    $91,%dh
	jb      RL_Rid_scr
	movb    %cl,%ah
	sahf    
	rclb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RL_Rid_scr:
	testb   $192,%dh
	jz      RL_Rid_rom
	movb    %cl,%ah
	sahf    
	rclb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      RL_Rid_rend
	cmpl    $86,%edi
	jle     RL_Rid_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RL_Rid_rom:
	movb    (%edx),%al
	movb    %cl,%ah
	sahf    
	rclb    %al
	movb    %al,%al
	call    rotshflags

RL_Rid_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rl_a:
	movb    %cl,%ah
	sahf    
	rclb    %ch
	movb    %ch,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rr_b:
	movb    %cl,%ah
	sahf    
	rcrb    %bh
	movb    %bh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rr_c:
	movb    %cl,%ah
	sahf    
	rcrb    %bl
	movb    %bl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rr_d:
	movb    %cl,%ah
	sahf    
	rcrb    z80_proc+5
	movb    z80_proc+5,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rr_e:
	movb    %cl,%ah
	sahf    
	rcrb    z80_proc+4
	movb    z80_proc+4,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rr_h:
	movb    %cl,%ah
	sahf    
	rcrb    %dh
	movb    %dh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rr_l:
	movb    %cl,%ah
	sahf    
	rcrb    %dl
	movb    %dl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rr_ihl:
	cmpb    $91,%dh
	jb      RR_R_scr
	movb    %cl,%ah
	sahf    
	rcrb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RR_R_scr:
	testb   $192,%dh
	jz      RR_R_rom
	movb    %cl,%ah
	sahf    
	rcrb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      RR_R_rend
	cmpl    $86,%edi
	jle     RR_R_rend
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RR_R_rom:
	movb    (%edx),%al
	movb    %cl,%ah
	sahf    
	rcrb    %al
	movb    %al,%al
	call    rotshflags

RR_R_rend:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rr_id:
	cmpb    $91,%dh
	jb      RR_Rid_scr
	movb    %cl,%ah
	sahf    
	rcrb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RR_Rid_scr:
	testb   $192,%dh
	jz      RR_Rid_rom
	movb    %cl,%ah
	sahf    
	rcrb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      RR_Rid_rend
	cmpl    $86,%edi
	jle     RR_Rid_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

RR_Rid_rom:
	movb    (%edx),%al
	movb    %cl,%ah
	sahf    
	rcrb    %al
	movb    %al,%al
	call    rotshflags

RR_Rid_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

rr_a:
	movb    %cl,%ah
	sahf    
	rcrb    %ch
	movb    %ch,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sla_b:
	salb    %bh
	movb    %bh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sla_c:
	salb    %bl
	movb    %bl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sla_d:
	salb    z80_proc+5
	movb    z80_proc+5,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sla_e:
	salb    z80_proc+4
	movb    z80_proc+4,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sla_h:
	salb    %dh
	movb    %dh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sla_l:
	salb    %dl
	movb    %dl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sla_ihl:
	cmpb    $91,%dh
	jb      SLA_R_scr
	salb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SLA_R_scr:
	testb   $192,%dh
	jz      SLA_R_rom
	salb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      SLA_R_rend
	cmpl    $86,%edi
	jle     SLA_R_rend
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SLA_R_rom:
	movb    (%edx),%al
	salb    %al
	movb    %al,%al
	call    rotshflags

SLA_R_rend:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sla_id:
	cmpb    $91,%dh
	jb      SLA_Rid_scr
	salb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SLA_Rid_scr:
	testb   $192,%dh
	jz      SLA_Rid_rom
	salb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      SLA_Rid_rend
	cmpl    $86,%edi
	jle     SLA_Rid_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SLA_Rid_rom:
	movb    (%edx),%al
	salb    %al
	movb    %al,%al
	call    rotshflags

SLA_Rid_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sla_a:
	salb    %ch
	movb    %ch,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sra_b:
	sarb    %bh
	movb    %bh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sra_c:
	sarb    %bl
	movb    %bl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sra_d:
	sarb    z80_proc+5
	movb    z80_proc+5,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sra_e:
	sarb    z80_proc+4
	movb    z80_proc+4,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sra_h:
	sarb    %dh
	movb    %dh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sra_l:
	sarb    %dl
	movb    %dl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sra_ihl:
	cmpb    $91,%dh
	jb      SRA_R_scr
	sarb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SRA_R_scr:
	testb   $192,%dh
	jz      SRA_R_rom
	sarb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      SRA_R_rend
	cmpl    $86,%edi
	jle     SRA_R_rend
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SRA_R_rom:
	movb    (%edx),%al
	sarb    %al
	movb    %al,%al
	call    rotshflags

SRA_R_rend:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sra_id:
	cmpb    $91,%dh
	jb      SRA_Rid_scr
	sarb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SRA_Rid_scr:
	testb   $192,%dh
	jz      SRA_Rid_rom
	sarb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      SRA_Rid_rend
	cmpl    $86,%edi
	jle     SRA_Rid_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SRA_Rid_rom:
	movb    (%edx),%al
	sarb    %al
	movb    %al,%al
	call    rotshflags

SRA_Rid_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sra_a:
	sarb    %ch
	movb    %ch,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sll_b:
	shlb    %bh
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,%bh
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sll_c:
	shlb    %bl
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,%bl
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sll_d:
	shlb    z80_proc+5
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,z80_proc+5
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sll_e:
	shlb    z80_proc+4
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,z80_proc+4
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sll_h:
	shlb    %dh
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,%dh
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sll_l:
	shlb    %dl
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,%dl
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sll_ihl:
	cmpb    $91,%dh
	jb      SLL_R_scr
	shlb    (%edx)
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,(%edx)
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SLL_R_scr:
	testb   $192,%dh
	jz      SLL_R_rom
	shlb    (%edx)
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,(%edx)
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      SLL_R_rend
	cmpl    $86,%edi
	jle     SLL_R_rend
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SLL_R_rom:
	movb    (%edx),%al
	shlb    %al
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,%al
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl

SLL_R_rend:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sll_id:
	cmpb    $91,%dh
	jb      SLL_Rid_scr
	shlb    (%edx)
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,(%edx)
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SLL_Rid_scr:
	testb   $192,%dh
	jz      SLL_Rid_rom
	shlb    (%edx)
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,(%edx)
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      SLL_Rid_rend
	cmpl    $86,%edi
	jle     SLL_Rid_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SLL_Rid_rom:
	movb    (%edx),%al
	shlb    %al
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,%al
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl

SLL_Rid_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

sll_a:
	shlb    %ch
	lahf    
	andb    $40,%cl
	andb    $1,%ah
	orb     %ah,%cl
	orb     $1,%ch
	lahf    
	andb    $59,%cl
	andb    $196,%ah
	orb     %ah,%cl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

srl_b:
	shrb    %bh
	movb    %bh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

srl_c:
	shrb    %bl
	movb    %bl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

srl_d:
	shrb    z80_proc+5
	movb    z80_proc+5,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

srl_e:
	shrb    z80_proc+4
	movb    z80_proc+4,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

srl_h:
	shrb    %dh
	movb    %dh,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

srl_l:
	shrb    %dl
	movb    %dl,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

srl_ihl:
	cmpb    $91,%dh
	jb      SRL_R_scr
	shrb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SRL_R_scr:
	testb   $192,%dh
	jz      SRL_R_rom
	shrb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      SRL_R_rend
	cmpl    $86,%edi
	jle     SRL_R_rend
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SRL_R_rom:
	movb    (%edx),%al
	shrb    %al
	movb    %al,%al
	call    rotshflags

SRL_R_rend:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

srl_id:
	cmpb    $91,%dh
	jb      SRL_Rid_scr
	shrb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SRL_Rid_scr:
	testb   $192,%dh
	jz      SRL_Rid_rom
	shrb    (%edx)
	movb    (%edx),%al
	call    rotshflags
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      SRL_Rid_rend
	cmpl    $86,%edi
	jle     SRL_Rid_rend
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

SRL_Rid_rom:
	movb    (%edx),%al
	shrb    %al
	movb    %al,%al
	call    rotshflags

SRL_Rid_rend:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

srl_a:
	shrb    %ch
	movb    %ch,%al
	call    rotshflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_0_b:
	movb    %bh,%al
	testb   $1,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_0_c:
	movb    %bl,%al
	testb   $1,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_0_d:
	movb    z80_proc+5,%al
	testb   $1,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_0_e:
	movb    z80_proc+4,%al
	testb   $1,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_0_h:
	movb    %dh,%al
	testb   $1,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_0_l:
	movb    %dl,%al
	testb   $1,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_0_ihl:
	movb    (%edx),%al
	testb   $1,%al
	call    bitflags
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_0_id:
	movb    (%edx),%al
	testb   $1,%al
	call    bitflags
	popl    %edx
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_0_a:
	movb    %ch,%al
	testb   $1,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_1_b:
	movb    %bh,%al
	testb   $2,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_1_c:
	movb    %bl,%al
	testb   $2,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_1_d:
	movb    z80_proc+5,%al
	testb   $2,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_1_e:
	movb    z80_proc+4,%al
	testb   $2,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_1_h:
	movb    %dh,%al
	testb   $2,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_1_l:
	movb    %dl,%al
	testb   $2,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_1_ihl:
	movb    (%edx),%al
	testb   $2,%al
	call    bitflags
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_1_id:
	movb    (%edx),%al
	testb   $2,%al
	call    bitflags
	popl    %edx
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_1_a:
	movb    %ch,%al
	testb   $2,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_2_b:
	movb    %bh,%al
	testb   $4,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_2_c:
	movb    %bl,%al
	testb   $4,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_2_d:
	movb    z80_proc+5,%al
	testb   $4,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_2_e:
	movb    z80_proc+4,%al
	testb   $4,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_2_h:
	movb    %dh,%al
	testb   $4,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_2_l:
	movb    %dl,%al
	testb   $4,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_2_ihl:
	movb    (%edx),%al
	testb   $4,%al
	call    bitflags
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_2_id:
	movb    (%edx),%al
	testb   $4,%al
	call    bitflags
	popl    %edx
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_2_a:
	movb    %ch,%al
	testb   $4,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_3_b:
	movb    %bh,%al
	testb   $8,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_3_c:
	movb    %bl,%al
	testb   $8,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_3_d:
	movb    z80_proc+5,%al
	testb   $8,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_3_e:
	movb    z80_proc+4,%al
	testb   $8,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_3_h:
	movb    %dh,%al
	testb   $8,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_3_l:
	movb    %dl,%al
	testb   $8,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_3_ihl:
	movb    (%edx),%al
	testb   $8,%al
	call    bitflags
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_3_id:
	movb    (%edx),%al
	testb   $8,%al
	call    bitflags
	popl    %edx
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_3_a:
	movb    %ch,%al
	testb   $8,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_4_b:
	movb    %bh,%al
	testb   $16,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_4_c:
	movb    %bl,%al
	testb   $16,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_4_d:
	movb    z80_proc+5,%al
	testb   $16,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_4_e:
	movb    z80_proc+4,%al
	testb   $16,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_4_h:
	movb    %dh,%al
	testb   $16,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_4_l:
	movb    %dl,%al
	testb   $16,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_4_ihl:
	movb    (%edx),%al
	testb   $16,%al
	call    bitflags
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_4_id:
	movb    (%edx),%al
	testb   $16,%al
	call    bitflags
	popl    %edx
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_4_a:
	movb    %ch,%al
	testb   $16,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_5_b:
	movb    %bh,%al
	testb   $32,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_5_c:
	movb    %bl,%al
	testb   $32,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_5_d:
	movb    z80_proc+5,%al
	testb   $32,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_5_e:
	movb    z80_proc+4,%al
	testb   $32,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_5_h:
	movb    %dh,%al
	testb   $32,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_5_l:
	movb    %dl,%al
	testb   $32,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_5_ihl:
	movb    (%edx),%al
	testb   $32,%al
	call    bitflags
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_5_id:
	movb    (%edx),%al
	testb   $32,%al
	call    bitflags
	popl    %edx
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_5_a:
	movb    %ch,%al
	testb   $32,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_6_b:
	movb    %bh,%al
	testb   $64,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_6_c:
	movb    %bl,%al
	testb   $64,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_6_d:
	movb    z80_proc+5,%al
	testb   $64,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_6_e:
	movb    z80_proc+4,%al
	testb   $64,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_6_h:
	movb    %dh,%al
	testb   $64,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_6_l:
	movb    %dl,%al
	testb   $64,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_6_ihl:
	movb    (%edx),%al
	testb   $64,%al
	call    bitflags
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_6_id:
	movb    (%edx),%al
	testb   $64,%al
	call    bitflags
	popl    %edx
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_6_a:
	movb    %ch,%al
	testb   $64,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_7_b:
	movb    %bh,%al
	testb   $128,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_7_c:
	movb    %bl,%al
	testb   $128,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_7_d:
	movb    z80_proc+5,%al
	testb   $128,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_7_e:
	movb    z80_proc+4,%al
	testb   $128,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_7_h:
	movb    %dh,%al
	testb   $128,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_7_l:
	movb    %dl,%al
	testb   $128,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_7_ihl:
	movb    (%edx),%al
	testb   $128,%al
	call    bitflags
	incl    z80_proc+76
	subl    $12,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_7_id:
	movb    (%edx),%al
	testb   $128,%al
	call    bitflags
	popl    %edx
	incl    z80_proc+76
	subl    $16,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

bit_7_a:
	movb    %ch,%al
	testb   $128,%al
	call    bitflags
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pm15:
	cmpb    $91,%dh
	jb      pm15_scr
	movb    %al,(%edx)
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pm15_scr:
	testb   $192,%dh
	jz      pm15_rom
	movb    %al,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      pm15_rom
	cmpl    $86,%edi
	jle     pm15_rom
	subl    $2,%edi
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pm15_rom:
	incl    z80_proc+76
	subl    $15,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pm23:
	cmpb    $91,%dh
	jb      pm23_scr
	movb    %al,(%edx)
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pm23_scr:
	testb   $192,%dh
	jz      pm23_rom
	movb    %al,(%edx)
	movzwl  %dx,%eax
	btsl    %eax,sp_scr_mark
	cmpl    $0,z80_proc+80
	jl      pm23_rom
	cmpl    $86,%edi
	jle     pm23_rom
	subl    $2,%edi
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

pm23_rom:
	popl    %edx
	incl    z80_proc+76
	subl    $19,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_0_b:
	andb    $254,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_0_c:
	andb    $254,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_0_d:
	andb    $254,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_0_e:
	andb    $254,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_0_h:
	andb    $254,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_0_l:
	andb    $254,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_0_ihl:
	movb    (%edx),%al
	andb    $254,%al
	jmp     pm15

res_0_id:
	movb    (%edx),%al
	andb    $254,%al
	jmp     pm23

res_0_a:
	andb    $254,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_1_b:
	andb    $253,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_1_c:
	andb    $253,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_1_d:
	andb    $253,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_1_e:
	andb    $253,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_1_h:
	andb    $253,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_1_l:
	andb    $253,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_1_ihl:
	movb    (%edx),%al
	andb    $253,%al
	jmp     pm15

res_1_id:
	movb    (%edx),%al
	andb    $253,%al
	jmp     pm23

res_1_a:
	andb    $253,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_2_b:
	andb    $251,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_2_c:
	andb    $251,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_2_d:
	andb    $251,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_2_e:
	andb    $251,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_2_h:
	andb    $251,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_2_l:
	andb    $251,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_2_ihl:
	movb    (%edx),%al
	andb    $251,%al
	jmp     pm15

res_2_id:
	movb    (%edx),%al
	andb    $251,%al
	jmp     pm23

res_2_a:
	andb    $251,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_3_b:
	andb    $247,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_3_c:
	andb    $247,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_3_d:
	andb    $247,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_3_e:
	andb    $247,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_3_h:
	andb    $247,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_3_l:
	andb    $247,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_3_ihl:
	movb    (%edx),%al
	andb    $247,%al
	jmp     pm15

res_3_id:
	movb    (%edx),%al
	andb    $247,%al
	jmp     pm23

res_3_a:
	andb    $247,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_4_b:
	andb    $239,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_4_c:
	andb    $239,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_4_d:
	andb    $239,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_4_e:
	andb    $239,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_4_h:
	andb    $239,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_4_l:
	andb    $239,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_4_ihl:
	movb    (%edx),%al
	andb    $239,%al
	jmp     pm15

res_4_id:
	movb    (%edx),%al
	andb    $239,%al
	jmp     pm23

res_4_a:
	andb    $239,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_5_b:
	andb    $223,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_5_c:
	andb    $223,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_5_d:
	andb    $223,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_5_e:
	andb    $223,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_5_h:
	andb    $223,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_5_l:
	andb    $223,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_5_ihl:
	movb    (%edx),%al
	andb    $223,%al
	jmp     pm15

res_5_id:
	movb    (%edx),%al
	andb    $223,%al
	jmp     pm23

res_5_a:
	andb    $223,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_6_b:
	andb    $191,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_6_c:
	andb    $191,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_6_d:
	andb    $191,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_6_e:
	andb    $191,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_6_h:
	andb    $191,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_6_l:
	andb    $191,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_6_ihl:
	movb    (%edx),%al
	andb    $191,%al
	jmp     pm15

res_6_id:
	movb    (%edx),%al
	andb    $191,%al
	jmp     pm23

res_6_a:
	andb    $191,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_7_b:
	andb    $127,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_7_c:
	andb    $127,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_7_d:
	andb    $127,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_7_e:
	andb    $127,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_7_h:
	andb    $127,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_7_l:
	andb    $127,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

res_7_ihl:
	movb    (%edx),%al
	andb    $127,%al
	jmp     pm15

res_7_id:
	movb    (%edx),%al
	andb    $127,%al
	jmp     pm23

res_7_a:
	andb    $127,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_0_b:
	orb     $1,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_0_c:
	orb     $1,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_0_d:
	orb     $1,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_0_e:
	orb     $1,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_0_h:
	orb     $1,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_0_l:
	orb     $1,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_0_ihl:
	movb    (%edx),%al
	orb     $1,%al
	jmp     pm15

set_0_id:
	movb    (%edx),%al
	orb     $1,%al
	jmp     pm23

set_0_a:
	orb     $1,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_1_b:
	orb     $2,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_1_c:
	orb     $2,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_1_d:
	orb     $2,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_1_e:
	orb     $2,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_1_h:
	orb     $2,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_1_l:
	orb     $2,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_1_ihl:
	movb    (%edx),%al
	orb     $2,%al
	jmp     pm15

set_1_id:
	movb    (%edx),%al
	orb     $2,%al
	jmp     pm23

set_1_a:
	orb     $2,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_2_b:
	orb     $4,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_2_c:
	orb     $4,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_2_d:
	orb     $4,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_2_e:
	orb     $4,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_2_h:
	orb     $4,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_2_l:
	orb     $4,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_2_ihl:
	movb    (%edx),%al
	orb     $4,%al
	jmp     pm15

set_2_id:
	movb    (%edx),%al
	orb     $4,%al
	jmp     pm23

set_2_a:
	orb     $4,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_3_b:
	orb     $8,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_3_c:
	orb     $8,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_3_d:
	orb     $8,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_3_e:
	orb     $8,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_3_h:
	orb     $8,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_3_l:
	orb     $8,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_3_ihl:
	movb    (%edx),%al
	orb     $8,%al
	jmp     pm15

set_3_id:
	movb    (%edx),%al
	orb     $8,%al
	jmp     pm23

set_3_a:
	orb     $8,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_4_b:
	orb     $16,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_4_c:
	orb     $16,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_4_d:
	orb     $16,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_4_e:
	orb     $16,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_4_h:
	orb     $16,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_4_l:
	orb     $16,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_4_ihl:
	movb    (%edx),%al
	orb     $16,%al
	jmp     pm15

set_4_id:
	movb    (%edx),%al
	orb     $16,%al
	jmp     pm23

set_4_a:
	orb     $16,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_5_b:
	orb     $32,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_5_c:
	orb     $32,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_5_d:
	orb     $32,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_5_e:
	orb     $32,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_5_h:
	orb     $32,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_5_l:
	orb     $32,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_5_ihl:
	movb    (%edx),%al
	orb     $32,%al
	jmp     pm15

set_5_id:
	movb    (%edx),%al
	orb     $32,%al
	jmp     pm23

set_5_a:
	orb     $32,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_6_b:
	orb     $64,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_6_c:
	orb     $64,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_6_d:
	orb     $64,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_6_e:
	orb     $64,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_6_h:
	orb     $64,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_6_l:
	orb     $64,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_6_ihl:
	movb    (%edx),%al
	orb     $64,%al
	jmp     pm15

set_6_id:
	movb    (%edx),%al
	orb     $64,%al
	jmp     pm23

set_6_a:
	orb     $64,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_7_b:
	orb     $128,%bh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_7_c:
	orb     $128,%bl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_7_d:
	orb     $128,z80_proc+5
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_7_e:
	orb     $128,z80_proc+4
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_7_h:
	orb     $128,%dh
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_7_l:
	orb     $128,%dl
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4

set_7_ihl:
	movb    (%edx),%al
	orb     $128,%al
	jmp     pm15

set_7_id:
	movb    (%edx),%al
	orb     $128,%al
	jmp     pm23

set_7_a:
	orb     $128,%ch
	incl    z80_proc+76
	subl    $8,%edi
	jng     loop_end
	movzbl  (%esi),%eax
	incw    %si
	jmp     *intr_table(,%eax,4)
	.align  4
	.data   

intr_table:
	.long   nop
	.long   ld_bc_nn
	.long   ld_ibc_a
	.long   inc_bc
	.long   inc_b
	.long   dec_b
	.long   ld_b_n
	.long   rlca
	.long   ex_af_afb
	.long   add_hl_bc
	.long   ld_a_ibc
	.long   dec_bc
	.long   inc_c
	.long   dec_c
	.long   ld_c_n
	.long   rrca
	.long   djnz_e
	.long   ld_de_nn
	.long   ld_ide_a
	.long   inc_de
	.long   inc_d
	.long   dec_d
	.long   ld_d_n
	.long   rla
	.long   jr_e
	.long   add_hl_de
	.long   ld_a_ide
	.long   dec_de
	.long   inc_e
	.long   dec_e
	.long   ld_e_n
	.long   rra
	.long   jr_nz_e
	.long   ld_hl_nn
	.long   ld_inn_hl
	.long   inc_hl
	.long   inc_h
	.long   dec_h
	.long   ld_h_n
	.long   daa
	.long   jr_z_e
	.long   add_hl_hl
	.long   ld_hl_inn
	.long   dec_hl
	.long   inc_l
	.long   dec_l
	.long   ld_l_n
	.long   cpl
	.long   jr_nc_e
	.long   ld_sp_nn
	.long   ld_inn_a
	.long   inc_sp
	.long   inc_ihl
	.long   dec_ihl
	.long   ld_ihl_n
	.long   scf
	.long   jr_c_e
	.long   add_hl_sp
	.long   ld_a_inn
	.long   dec_sp
	.long   inc_a
	.long   dec_a
	.long   ld_a_n
	.long   ccf
	.long   nop
	.long   ld_b_c
	.long   ld_b_d
	.long   ld_b_e
	.long   ld_b_h
	.long   ld_b_l
	.long   ld_b_ihl
	.long   ld_b_a
	.long   ld_c_b
	.long   nop
	.long   ld_c_d
	.long   ld_c_e
	.long   ld_c_h
	.long   ld_c_l
	.long   ld_c_ihl
	.long   ld_c_a
	.long   ld_d_b
	.long   ld_d_c
	.long   nop
	.long   ld_d_e
	.long   ld_d_h
	.long   ld_d_l
	.long   ld_d_ihl
	.long   ld_d_a
	.long   ld_e_b
	.long   ld_e_c
	.long   ld_e_d
	.long   nop
	.long   ld_e_h
	.long   ld_e_l
	.long   ld_e_ihl
	.long   ld_e_a
	.long   ld_h_b
	.long   ld_h_c
	.long   ld_h_d
	.long   ld_h_e
	.long   nop
	.long   ld_h_l
	.long   ld_h_ihl
	.long   ld_h_a
	.long   ld_l_b
	.long   ld_l_c
	.long   ld_l_d
	.long   ld_l_e
	.long   ld_l_h
	.long   nop
	.long   ld_l_ihl
	.long   ld_l_a
	.long   ld_ihl_b
	.long   ld_ihl_c
	.long   ld_ihl_d
	.long   ld_ihl_e
	.long   ld_ihl_h
	.long   ld_ihl_l
	.long   halt
	.long   ld_ihl_a
	.long   ld_a_b
	.long   ld_a_c
	.long   ld_a_d
	.long   ld_a_e
	.long   ld_a_h
	.long   ld_a_l
	.long   ld_a_ihl
	.long   nop
	.long   add_a_b
	.long   add_a_c
	.long   add_a_d
	.long   add_a_e
	.long   add_a_h
	.long   add_a_l
	.long   add_a_ihl
	.long   add_a_a
	.long   adc_a_b
	.long   adc_a_c
	.long   adc_a_d
	.long   adc_a_e
	.long   adc_a_h
	.long   adc_a_l
	.long   adc_a_ihl
	.long   adc_a_a
	.long   sub_b
	.long   sub_c
	.long   sub_d
	.long   sub_e
	.long   sub_h
	.long   sub_l
	.long   sub_ihl
	.long   sub_a
	.long   sbc_a_b
	.long   sbc_a_c
	.long   sbc_a_d
	.long   sbc_a_e
	.long   sbc_a_h
	.long   sbc_a_l
	.long   sbc_a_ihl
	.long   sbc_a_a
	.long   and_b
	.long   and_c
	.long   and_d
	.long   and_e
	.long   and_h
	.long   and_l
	.long   and_ihl
	.long   and_a
	.long   xor_b
	.long   xor_c
	.long   xor_d
	.long   xor_e
	.long   xor_h
	.long   xor_l
	.long   xor_ihl
	.long   xor_a
	.long   or_b
	.long   or_c
	.long   or_d
	.long   or_e
	.long   or_h
	.long   or_l
	.long   or_ihl
	.long   or_a
	.long   cp_b
	.long   cp_c
	.long   cp_d
	.long   cp_e
	.long   cp_h
	.long   cp_l
	.long   cp_ihl
	.long   cp_a
	.long   ret_nz
	.long   pop_bc
	.long   jp_nz_nn
	.long   jp_nn
	.long   call_nz_nn
	.long   push_bc
	.long   add_a_n
	.long   rst_00
	.long   ret_z
	.long   ret
	.long   jp_z_nn
	.long   special_cb
	.long   call_z_nn
	.long   call_nn
	.long   adc_a_n
	.long   rst_08
	.long   ret_nc
	.long   pop_de
	.long   jp_nc_nn
	.long   out_in_a
	.long   call_nc_nn
	.long   push_de
	.long   sub_n
	.long   rst_10
	.long   ret_c
	.long   exx
	.long   jp_c_nn
	.long   in_a_in
	.long   call_c_nn
	.long   special_dd
	.long   sbc_a_n
	.long   rst_18
	.long   ret_po
	.long   pop_hl
	.long   jp_po_nn
	.long   ex_isp_hl
	.long   call_po_nn
	.long   push_hl
	.long   and_n
	.long   rst_20
	.long   ret_pe
	.long   jp_hl
	.long   jp_pe_nn
	.long   ex_de_hl
	.long   call_pe_nn
	.long   special_ed
	.long   xor_n
	.long   rst_28
	.long   ret_p
	.long   pop_af
	.long   jp_p_nn
	.long   di
	.long   call_p_nn
	.long   push_af
	.long   or_n
	.long   rst_30
	.long   ret_m
	.long   ld_sp_hl
	.long   jp_m_nn
	.long   ei
	.long   call_m_nn
	.long   special_fd
	.long   cp_n
	.long   rst_38
	.align  4

intr_table_dd:
	.long   nop
	.long   ld_bc_nn
	.long   ld_ibc_a
	.long   inc_bc
	.long   inc_b
	.long   dec_b
	.long   ld_b_n
	.long   rlca
	.long   ex_af_afb
	.long   add_ix_bc
	.long   ld_a_ibc
	.long   dec_bc
	.long   inc_c
	.long   dec_c
	.long   ld_c_n
	.long   rrca
	.long   djnz_e
	.long   ld_de_nn
	.long   ld_ide_a
	.long   inc_de
	.long   inc_d
	.long   dec_d
	.long   ld_d_n
	.long   rla
	.long   jr_e
	.long   add_ix_de
	.long   ld_a_ide
	.long   dec_de
	.long   inc_e
	.long   dec_e
	.long   ld_e_n
	.long   rra
	.long   jr_nz_e
	.long   ld_ix_nn
	.long   ld_inn_ix
	.long   inc_ix
	.long   inc_ixh
	.long   dec_ixh
	.long   ld_ixh_n
	.long   daa
	.long   jr_z_e
	.long   add_ix_ix
	.long   ld_ix_inn
	.long   dec_ix
	.long   inc_ixl
	.long   dec_ixl
	.long   ld_ixl_n
	.long   cpl
	.long   jr_nc_e
	.long   ld_sp_nn
	.long   ld_inn_a
	.long   inc_sp
	.long   inc_iixd
	.long   dec_iixd
	.long   ld_iixd_n
	.long   scf
	.long   jr_c_e
	.long   add_ix_sp
	.long   ld_a_inn
	.long   dec_sp
	.long   inc_a
	.long   dec_a
	.long   ld_a_n
	.long   ccf
	.long   nop
	.long   ld_b_c
	.long   ld_b_d
	.long   ld_b_e
	.long   ld_b_ixh
	.long   ld_b_ixl
	.long   ld_b_iixd
	.long   ld_b_a
	.long   ld_c_b
	.long   nop
	.long   ld_c_d
	.long   ld_c_e
	.long   ld_c_ixh
	.long   ld_c_ixl
	.long   ld_c_iixd
	.long   ld_c_a
	.long   ld_d_b
	.long   ld_d_c
	.long   nop
	.long   ld_d_e
	.long   ld_d_ixh
	.long   ld_d_ixl
	.long   ld_d_iixd
	.long   ld_d_a
	.long   ld_e_b
	.long   ld_e_c
	.long   ld_e_d
	.long   nop
	.long   ld_e_ixh
	.long   ld_e_ixl
	.long   ld_e_iixd
	.long   ld_e_a
	.long   ld_ixh_b
	.long   ld_ixh_c
	.long   ld_ixh_d
	.long   ld_ixh_e
	.long   nop
	.long   ld_ixh_ixl
	.long   ld_h_iixd
	.long   ld_ixh_a
	.long   ld_ixl_b
	.long   ld_ixl_c
	.long   ld_ixl_d
	.long   ld_ixl_e
	.long   ld_ixl_ixh
	.long   nop
	.long   ld_l_iixd
	.long   ld_ixl_a
	.long   ld_iixd_b
	.long   ld_iixd_c
	.long   ld_iixd_d
	.long   ld_iixd_e
	.long   ld_iixd_h
	.long   ld_iixd_l
	.long   halt
	.long   ld_iixd_a
	.long   ld_a_b
	.long   ld_a_c
	.long   ld_a_d
	.long   ld_a_e
	.long   ld_a_ixh
	.long   ld_a_ixl
	.long   ld_a_iixd
	.long   nop
	.long   add_a_b
	.long   add_a_c
	.long   add_a_d
	.long   add_a_e
	.long   add_a_ixh
	.long   add_a_ixl
	.long   add_a_iixd
	.long   add_a_a
	.long   adc_a_b
	.long   adc_a_c
	.long   adc_a_d
	.long   adc_a_e
	.long   adc_a_ixh
	.long   adc_a_ixl
	.long   adc_a_iixd
	.long   adc_a_a
	.long   sub_b
	.long   sub_c
	.long   sub_d
	.long   sub_e
	.long   sub_ixh
	.long   sub_ixl
	.long   sub_iixd
	.long   sub_a
	.long   sbc_a_b
	.long   sbc_a_c
	.long   sbc_a_d
	.long   sbc_a_e
	.long   sbc_a_ixh
	.long   sbc_a_ixl
	.long   sbc_a_iixd
	.long   sbc_a_a
	.long   and_b
	.long   and_c
	.long   and_d
	.long   and_e
	.long   and_ixh
	.long   and_ixl
	.long   and_iixd
	.long   and_a
	.long   xor_b
	.long   xor_c
	.long   xor_d
	.long   xor_e
	.long   xor_ixh
	.long   xor_ixl
	.long   xor_iixd
	.long   xor_a
	.long   or_b
	.long   or_c
	.long   or_d
	.long   or_e
	.long   or_ixh
	.long   or_ixl
	.long   or_iixd
	.long   or_a
	.long   cp_b
	.long   cp_c
	.long   cp_d
	.long   cp_e
	.long   cp_ixh
	.long   cp_ixl
	.long   cp_iixd
	.long   cp_a
	.long   ret_nz
	.long   pop_bc
	.long   jp_nz_nn
	.long   jp_nn
	.long   call_nz_nn
	.long   push_bc
	.long   add_a_n
	.long   rst_00
	.long   ret_z
	.long   ret
	.long   jp_z_nn
	.long   special_dd_cb
	.long   call_z_nn
	.long   call_nn
	.long   adc_a_n
	.long   rst_08
	.long   ret_nc
	.long   pop_de
	.long   jp_nc_nn
	.long   out_in_a
	.long   call_nc_nn
	.long   push_de
	.long   sub_n
	.long   rst_10
	.long   ret_c
	.long   exx
	.long   jp_c_nn
	.long   in_a_in
	.long   call_c_nn
	.long   special_xx
	.long   sbc_a_n
	.long   rst_18
	.long   ret_po
	.long   pop_ix
	.long   jp_po_nn
	.long   ex_isp_ix
	.long   call_po_nn
	.long   push_ix
	.long   and_n
	.long   rst_20
	.long   ret_pe
	.long   jp_ix
	.long   jp_pe_nn
	.long   ex_de_hl
	.long   call_pe_nn
	.long   special_ed
	.long   xor_n
	.long   rst_28
	.long   ret_p
	.long   pop_af
	.long   jp_p_nn
	.long   di
	.long   call_p_nn
	.long   push_af
	.long   or_n
	.long   rst_30
	.long   ret_m
	.long   ld_sp_ix
	.long   jp_m_nn
	.long   ei
	.long   call_m_nn
	.long   special_xx
	.long   cp_n
	.long   rst_38
	.align  4

intr_table_fd:
	.long   nop
	.long   ld_bc_nn
	.long   ld_ibc_a
	.long   inc_bc
	.long   inc_b
	.long   dec_b
	.long   ld_b_n
	.long   rlca
	.long   ex_af_afb
	.long   add_iy_bc
	.long   ld_a_ibc
	.long   dec_bc
	.long   inc_c
	.long   dec_c
	.long   ld_c_n
	.long   rrca
	.long   djnz_e
	.long   ld_de_nn
	.long   ld_ide_a
	.long   inc_de
	.long   inc_d
	.long   dec_d
	.long   ld_d_n
	.long   rla
	.long   jr_e
	.long   add_iy_de
	.long   ld_a_ide
	.long   dec_de
	.long   inc_e
	.long   dec_e
	.long   ld_e_n
	.long   rra
	.long   jr_nz_e
	.long   ld_iy_nn
	.long   ld_inn_iy
	.long   inc_iy
	.long   inc_iyh
	.long   dec_iyh
	.long   ld_iyh_n
	.long   daa
	.long   jr_z_e
	.long   add_iy_iy
	.long   ld_iy_inn
	.long   dec_iy
	.long   inc_iyl
	.long   dec_iyl
	.long   ld_iyl_n
	.long   cpl
	.long   jr_nc_e
	.long   ld_sp_nn
	.long   ld_inn_a
	.long   inc_sp
	.long   inc_iiyd
	.long   dec_iiyd
	.long   ld_iiyd_n
	.long   scf
	.long   jr_c_e
	.long   add_iy_sp
	.long   ld_a_inn
	.long   dec_sp
	.long   inc_a
	.long   dec_a
	.long   ld_a_n
	.long   ccf
	.long   nop
	.long   ld_b_c
	.long   ld_b_d
	.long   ld_b_e
	.long   ld_b_iyh
	.long   ld_b_iyl
	.long   ld_b_iiyd
	.long   ld_b_a
	.long   ld_c_b
	.long   nop
	.long   ld_c_d
	.long   ld_c_e
	.long   ld_c_iyh
	.long   ld_c_iyl
	.long   ld_c_iiyd
	.long   ld_c_a
	.long   ld_d_b
	.long   ld_d_c
	.long   nop
	.long   ld_d_e
	.long   ld_d_iyh
	.long   ld_d_iyl
	.long   ld_d_iiyd
	.long   ld_d_a
	.long   ld_e_b
	.long   ld_e_c
	.long   ld_e_d
	.long   nop
	.long   ld_e_iyh
	.long   ld_e_iyl
	.long   ld_e_iiyd
	.long   ld_e_a
	.long   ld_iyh_b
	.long   ld_iyh_c
	.long   ld_iyh_d
	.long   ld_iyh_e
	.long   nop
	.long   ld_iyh_iyl
	.long   ld_h_iiyd
	.long   ld_iyh_a
	.long   ld_iyl_b
	.long   ld_iyl_c
	.long   ld_iyl_d
	.long   ld_iyl_e
	.long   ld_iyl_iyh
	.long   nop
	.long   ld_l_iiyd
	.long   ld_iyl_a
	.long   ld_iiyd_b
	.long   ld_iiyd_c
	.long   ld_iiyd_d
	.long   ld_iiyd_e
	.long   ld_iiyd_h
	.long   ld_iiyd_l
	.long   halt
	.long   ld_iiyd_a
	.long   ld_a_b
	.long   ld_a_c
	.long   ld_a_d
	.long   ld_a_e
	.long   ld_a_iyh
	.long   ld_a_iyl
	.long   ld_a_iiyd
	.long   nop
	.long   add_a_b
	.long   add_a_c
	.long   add_a_d
	.long   add_a_e
	.long   add_a_iyh
	.long   add_a_iyl
	.long   add_a_iiyd
	.long   add_a_a
	.long   adc_a_b
	.long   adc_a_c
	.long   adc_a_d
	.long   adc_a_e
	.long   adc_a_iyh
	.long   adc_a_iyl
	.long   adc_a_iiyd
	.long   adc_a_a
	.long   sub_b
	.long   sub_c
	.long   sub_d
	.long   sub_e
	.long   sub_iyh
	.long   sub_iyl
	.long   sub_iiyd
	.long   sub_a
	.long   sbc_a_b
	.long   sbc_a_c
	.long   sbc_a_d
	.long   sbc_a_e
	.long   sbc_a_iyh
	.long   sbc_a_iyl
	.long   sbc_a_iiyd
	.long   sbc_a_a
	.long   and_b
	.long   and_c
	.long   and_d
	.long   and_e
	.long   and_iyh
	.long   and_iyl
	.long   and_iiyd
	.long   and_a
	.long   xor_b
	.long   xor_c
	.long   xor_d
	.long   xor_e
	.long   xor_iyh
	.long   xor_iyl
	.long   xor_iiyd
	.long   xor_a
	.long   or_b
	.long   or_c
	.long   or_d
	.long   or_e
	.long   or_iyh
	.long   or_iyl
	.long   or_iiyd
	.long   or_a
	.long   cp_b
	.long   cp_c
	.long   cp_d
	.long   cp_e
	.long   cp_iyh
	.long   cp_iyl
	.long   cp_iiyd
	.long   cp_a
	.long   ret_nz
	.long   pop_bc
	.long   jp_nz_nn
	.long   jp_nn
	.long   call_nz_nn
	.long   push_bc
	.long   add_a_n
	.long   rst_00
	.long   ret_z
	.long   ret
	.long   jp_z_nn
	.long   special_fd_cb
	.long   call_z_nn
	.long   call_nn
	.long   adc_a_n
	.long   rst_08
	.long   ret_nc
	.long   pop_de
	.long   jp_nc_nn
	.long   out_in_a
	.long   call_nc_nn
	.long   push_de
	.long   sub_n
	.long   rst_10
	.long   ret_c
	.long   exx
	.long   jp_c_nn
	.long   in_a_in
	.long   call_c_nn
	.long   special_xx
	.long   sbc_a_n
	.long   rst_18
	.long   ret_po
	.long   pop_iy
	.long   jp_po_nn
	.long   ex_isp_iy
	.long   call_po_nn
	.long   push_iy
	.long   and_n
	.long   rst_20
	.long   ret_pe
	.long   jp_iy
	.long   jp_pe_nn
	.long   ex_de_hl
	.long   call_pe_nn
	.long   special_ed
	.long   xor_n
	.long   rst_28
	.long   ret_p
	.long   pop_af
	.long   jp_p_nn
	.long   di
	.long   call_p_nn
	.long   push_af
	.long   or_n
	.long   rst_30
	.long   ret_m
	.long   ld_sp_iy
	.long   jp_m_nn
	.long   ei
	.long   call_m_nn
	.long   special_xx
	.long   cp_n
	.long   rst_38
	.align  4

intr_table_ed:
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   in_b_ic
	.long   out_ic_b
	.long   sbc_hl_bc
	.long   ld_inn_bc
	.long   neg
	.long   retn
	.long   im_0
	.long   ld_i_a
	.long   in_c_ic
	.long   out_ic_c
	.long   adc_hl_bc
	.long   ld_bc_inn
	.long   neg
	.long   reti
	.long   im_0
	.long   ld_r_a
	.long   in_d_ic
	.long   out_ic_d
	.long   sbc_hl_de
	.long   ld_inn_de
	.long   neg
	.long   retn
	.long   im_1
	.long   ld_a_i
	.long   in_e_ic
	.long   out_ic_e
	.long   adc_hl_de
	.long   ld_de_inn
	.long   neg
	.long   retn
	.long   im_2
	.long   ld_a_r
	.long   in_h_ic
	.long   out_ic_h
	.long   sbc_hl_hl
	.long   ld_inn_hl_ed
	.long   neg
	.long   retn
	.long   im_0
	.long   rrd
	.long   in_l_ic
	.long   out_ic_l
	.long   adc_hl_hl
	.long   ld_hl_inn_ed
	.long   neg
	.long   retn
	.long   im_0
	.long   rld
	.long   in_f_ic
	.long   out_ic_0
	.long   sbc_hl_sp
	.long   ld_inn_sp
	.long   neg
	.long   retn
	.long   im_1
	.long   ill_ed
	.long   in_a_ic
	.long   out_ic_a
	.long   adc_hl_sp
	.long   ld_sp_inn
	.long   neg
	.long   retn
	.long   im_2
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ldi
	.long   cpi
	.long   ini
	.long   outi
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ldd
	.long   cpd
	.long   ind
	.long   outd
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ldir
	.long   cpir
	.long   inir
	.long   otir
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   lddr
	.long   cpdr
	.long   indr
	.long   otdr
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.long   ill_ed
	.align  4

intr_table_cb:
	.long   rlc_b
	.long   rlc_c
	.long   rlc_d
	.long   rlc_e
	.long   rlc_h
	.long   rlc_l
	.long   rlc_ihl
	.long   rlc_a
	.long   rrc_b
	.long   rrc_c
	.long   rrc_d
	.long   rrc_e
	.long   rrc_h
	.long   rrc_l
	.long   rrc_ihl
	.long   rrc_a
	.long   rl_b
	.long   rl_c
	.long   rl_d
	.long   rl_e
	.long   rl_h
	.long   rl_l
	.long   rl_ihl
	.long   rl_a
	.long   rr_b
	.long   rr_c
	.long   rr_d
	.long   rr_e
	.long   rr_h
	.long   rr_l
	.long   rr_ihl
	.long   rr_a
	.long   sla_b
	.long   sla_c
	.long   sla_d
	.long   sla_e
	.long   sla_h
	.long   sla_l
	.long   sla_ihl
	.long   sla_a
	.long   sra_b
	.long   sra_c
	.long   sra_d
	.long   sra_e
	.long   sra_h
	.long   sra_l
	.long   sra_ihl
	.long   sra_a
	.long   sll_b
	.long   sll_c
	.long   sll_d
	.long   sll_e
	.long   sll_h
	.long   sll_l
	.long   sll_ihl
	.long   sll_a
	.long   srl_b
	.long   srl_c
	.long   srl_d
	.long   srl_e
	.long   srl_h
	.long   srl_l
	.long   srl_ihl
	.long   srl_a
	.long   bit_0_b
	.long   bit_0_c
	.long   bit_0_d
	.long   bit_0_e
	.long   bit_0_h
	.long   bit_0_l
	.long   bit_0_ihl
	.long   bit_0_a
	.long   bit_1_b
	.long   bit_1_c
	.long   bit_1_d
	.long   bit_1_e
	.long   bit_1_h
	.long   bit_1_l
	.long   bit_1_ihl
	.long   bit_1_a
	.long   bit_2_b
	.long   bit_2_c
	.long   bit_2_d
	.long   bit_2_e
	.long   bit_2_h
	.long   bit_2_l
	.long   bit_2_ihl
	.long   bit_2_a
	.long   bit_3_b
	.long   bit_3_c
	.long   bit_3_d
	.long   bit_3_e
	.long   bit_3_h
	.long   bit_3_l
	.long   bit_3_ihl
	.long   bit_3_a
	.long   bit_4_b
	.long   bit_4_c
	.long   bit_4_d
	.long   bit_4_e
	.long   bit_4_h
	.long   bit_4_l
	.long   bit_4_ihl
	.long   bit_4_a
	.long   bit_5_b
	.long   bit_5_c
	.long   bit_5_d
	.long   bit_5_e
	.long   bit_5_h
	.long   bit_5_l
	.long   bit_5_ihl
	.long   bit_5_a
	.long   bit_6_b
	.long   bit_6_c
	.long   bit_6_d
	.long   bit_6_e
	.long   bit_6_h
	.long   bit_6_l
	.long   bit_6_ihl
	.long   bit_6_a
	.long   bit_7_b
	.long   bit_7_c
	.long   bit_7_d
	.long   bit_7_e
	.long   bit_7_h
	.long   bit_7_l
	.long   bit_7_ihl
	.long   bit_7_a
	.long   res_0_b
	.long   res_0_c
	.long   res_0_d
	.long   res_0_e
	.long   res_0_h
	.long   res_0_l
	.long   res_0_ihl
	.long   res_0_a
	.long   res_1_b
	.long   res_1_c
	.long   res_1_d
	.long   res_1_e
	.long   res_1_h
	.long   res_1_l
	.long   res_1_ihl
	.long   res_1_a
	.long   res_2_b
	.long   res_2_c
	.long   res_2_d
	.long   res_2_e
	.long   res_2_h
	.long   res_2_l
	.long   res_2_ihl
	.long   res_2_a
	.long   res_3_b
	.long   res_3_c
	.long   res_3_d
	.long   res_3_e
	.long   res_3_h
	.long   res_3_l
	.long   res_3_ihl
	.long   res_3_a
	.long   res_4_b
	.long   res_4_c
	.long   res_4_d
	.long   res_4_e
	.long   res_4_h
	.long   res_4_l
	.long   res_4_ihl
	.long   res_4_a
	.long   res_5_b
	.long   res_5_c
	.long   res_5_d
	.long   res_5_e
	.long   res_5_h
	.long   res_5_l
	.long   res_5_ihl
	.long   res_5_a
	.long   res_6_b
	.long   res_6_c
	.long   res_6_d
	.long   res_6_e
	.long   res_6_h
	.long   res_6_l
	.long   res_6_ihl
	.long   res_6_a
	.long   res_7_b
	.long   res_7_c
	.long   res_7_d
	.long   res_7_e
	.long   res_7_h
	.long   res_7_l
	.long   res_7_ihl
	.long   res_7_a
	.long   set_0_b
	.long   set_0_c
	.long   set_0_d
	.long   set_0_e
	.long   set_0_h
	.long   set_0_l
	.long   set_0_ihl
	.long   set_0_a
	.long   set_1_b
	.long   set_1_c
	.long   set_1_d
	.long   set_1_e
	.long   set_1_h
	.long   set_1_l
	.long   set_1_ihl
	.long   set_1_a
	.long   set_2_b
	.long   set_2_c
	.long   set_2_d
	.long   set_2_e
	.long   set_2_h
	.long   set_2_l
	.long   set_2_ihl
	.long   set_2_a
	.long   set_3_b
	.long   set_3_c
	.long   set_3_d
	.long   set_3_e
	.long   set_3_h
	.long   set_3_l
	.long   set_3_ihl
	.long   set_3_a
	.long   set_4_b
	.long   set_4_c
	.long   set_4_d
	.long   set_4_e
	.long   set_4_h
	.long   set_4_l
	.long   set_4_ihl
	.long   set_4_a
	.long   set_5_b
	.long   set_5_c
	.long   set_5_d
	.long   set_5_e
	.long   set_5_h
	.long   set_5_l
	.long   set_5_ihl
	.long   set_5_a
	.long   set_6_b
	.long   set_6_c
	.long   set_6_d
	.long   set_6_e
	.long   set_6_h
	.long   set_6_l
	.long   set_6_ihl
	.long   set_6_a
	.long   set_7_b
	.long   set_7_c
	.long   set_7_d
	.long   set_7_e
	.long   set_7_h
	.long   set_7_l
	.long   set_7_ihl
	.long   set_7_a
	.align  4

intr_table_dd_fd_cb:
	.long   rlc_b
	.long   rlc_c
	.long   rlc_d
	.long   rlc_e
	.long   rlc_h
	.long   rlc_l
	.long   rlc_id
	.long   rlc_a
	.long   rrc_b
	.long   rrc_c
	.long   rrc_d
	.long   rrc_e
	.long   rrc_h
	.long   rrc_l
	.long   rrc_id
	.long   rrc_a
	.long   rl_b
	.long   rl_c
	.long   rl_d
	.long   rl_e
	.long   rl_h
	.long   rl_l
	.long   rl_id
	.long   rl_a
	.long   rr_b
	.long   rr_c
	.long   rr_d
	.long   rr_e
	.long   rr_h
	.long   rr_l
	.long   rr_id
	.long   rr_a
	.long   sla_b
	.long   sla_c
	.long   sla_d
	.long   sla_e
	.long   sla_h
	.long   sla_l
	.long   sla_id
	.long   sla_a
	.long   sra_b
	.long   sra_c
	.long   sra_d
	.long   sra_e
	.long   sra_h
	.long   sra_l
	.long   sra_id
	.long   sra_a
	.long   sll_b
	.long   sll_c
	.long   sll_d
	.long   sll_e
	.long   sll_h
	.long   sll_l
	.long   sll_id
	.long   sll_a
	.long   srl_b
	.long   srl_c
	.long   srl_d
	.long   srl_e
	.long   srl_h
	.long   srl_l
	.long   srl_id
	.long   srl_a
	.long   bit_0_b
	.long   bit_0_c
	.long   bit_0_d
	.long   bit_0_e
	.long   bit_0_h
	.long   bit_0_l
	.long   bit_0_id
	.long   bit_0_a
	.long   bit_1_b
	.long   bit_1_c
	.long   bit_1_d
	.long   bit_1_e
	.long   bit_1_h
	.long   bit_1_l
	.long   bit_1_id
	.long   bit_1_a
	.long   bit_2_b
	.long   bit_2_c
	.long   bit_2_d
	.long   bit_2_e
	.long   bit_2_h
	.long   bit_2_l
	.long   bit_2_id
	.long   bit_2_a
	.long   bit_3_b
	.long   bit_3_c
	.long   bit_3_d
	.long   bit_3_e
	.long   bit_3_h
	.long   bit_3_l
	.long   bit_3_id
	.long   bit_3_a
	.long   bit_4_b
	.long   bit_4_c
	.long   bit_4_d
	.long   bit_4_e
	.long   bit_4_h
	.long   bit_4_l
	.long   bit_4_id
	.long   bit_4_a
	.long   bit_5_b
	.long   bit_5_c
	.long   bit_5_d
	.long   bit_5_e
	.long   bit_5_h
	.long   bit_5_l
	.long   bit_5_id
	.long   bit_5_a
	.long   bit_6_b
	.long   bit_6_c
	.long   bit_6_d
	.long   bit_6_e
	.long   bit_6_h
	.long   bit_6_l
	.long   bit_6_id
	.long   bit_6_a
	.long   bit_7_b
	.long   bit_7_c
	.long   bit_7_d
	.long   bit_7_e
	.long   bit_7_h
	.long   bit_7_l
	.long   bit_7_id
	.long   bit_7_a
	.long   res_0_b
	.long   res_0_c
	.long   res_0_d
	.long   res_0_e
	.long   res_0_h
	.long   res_0_l
	.long   res_0_id
	.long   res_0_a
	.long   res_1_b
	.long   res_1_c
	.long   res_1_d
	.long   res_1_e
	.long   res_1_h
	.long   res_1_l
	.long   res_1_id
	.long   res_1_a
	.long   res_2_b
	.long   res_2_c
	.long   res_2_d
	.long   res_2_e
	.long   res_2_h
	.long   res_2_l
	.long   res_2_id
	.long   res_2_a
	.long   res_3_b
	.long   res_3_c
	.long   res_3_d
	.long   res_3_e
	.long   res_3_h
	.long   res_3_l
	.long   res_3_id
	.long   res_3_a
	.long   res_4_b
	.long   res_4_c
	.long   res_4_d
	.long   res_4_e
	.long   res_4_h
	.long   res_4_l
	.long   res_4_id
	.long   res_4_a
	.long   res_5_b
	.long   res_5_c
	.long   res_5_d
	.long   res_5_e
	.long   res_5_h
	.long   res_5_l
	.long   res_5_id
	.long   res_5_a
	.long   res_6_b
	.long   res_6_c
	.long   res_6_d
	.long   res_6_e
	.long   res_6_h
	.long   res_6_l
	.long   res_6_id
	.long   res_6_a
	.long   res_7_b
	.long   res_7_c
	.long   res_7_d
	.long   res_7_e
	.long   res_7_h
	.long   res_7_l
	.long   res_7_id
	.long   res_7_a
	.long   set_0_b
	.long   set_0_c
	.long   set_0_d
	.long   set_0_e
	.long   set_0_h
	.long   set_0_l
	.long   set_0_id
	.long   set_0_a
	.long   set_1_b
	.long   set_1_c
	.long   set_1_d
	.long   set_1_e
	.long   set_1_h
	.long   set_1_l
	.long   set_1_id
	.long   set_1_a
	.long   set_2_b
	.long   set_2_c
	.long   set_2_d
	.long   set_2_e
	.long   set_2_h
	.long   set_2_l
	.long   set_2_id
	.long   set_2_a
	.long   set_3_b
	.long   set_3_c
	.long   set_3_d
	.long   set_3_e
	.long   set_3_h
	.long   set_3_l
	.long   set_3_id
	.long   set_3_a
	.long   set_4_b
	.long   set_4_c
	.long   set_4_d
	.long   set_4_e
	.long   set_4_h
	.long   set_4_l
	.long   set_4_id
	.long   set_4_a
	.long   set_5_b
	.long   set_5_c
	.long   set_5_d
	.long   set_5_e
	.long   set_5_h
	.long   set_5_l
	.long   set_5_id
	.long   set_5_a
	.long   set_6_b
	.long   set_6_c
	.long   set_6_d
	.long   set_6_e
	.long   set_6_h
	.long   set_6_l
	.long   set_6_id
	.long   set_6_a
	.long   set_7_b
	.long   set_7_c
	.long   set_7_d
	.long   set_7_e
	.long   set_7_h
	.long   set_7_l
	.long   set_7_id
	.long   set_7_a
	.align  4
	.text   
